
function EditAreaLoader(){
date= new Date();
this.start_time=date.getTime();
this.error= false;
this.baseURL="";
this.template="";
this.lang= new Array();
this.load_syntax= new Array();
this.syntax= new Array();
this.loadedFiles= new Array();
this.waiting_loading= new Array();
this.min_area_size= {"x": 400, "y": 100};
this.scripts_to_load= new Array();
this.sub_scripts_to_load= new Array();
this.resize= new Array();
this.default_settings= {
debug: false
,smooth_selection: true
,font_size: "10"
,font_family: "monospace"
,start_highlight: false
,toolbar: "search, go_to_line, |, undo, redo, |, select_font, change_smooth_selection, highlight, reset_highlight, |, help"
,begin_toolbar: ""
,end_toolbar: ""
,load_callback: ""
,save_callback: ""
,allow_resize: "both"
,allow_toogle: true
,language: "en"
,syntax: ""
,display: "onload"
,max_undo: 20
,browsers: "known"
};
this.advanced_buttons = [
['new_document', 'newdocument.gif', 'new_document'],
['search', 'search.gif', 'show_search'],
['go_to_line', 'go_to_line.gif', 'go_to_line'],
['undo', 'undo.gif', 'undo'],
['redo', 'redo.gif', 'redo'],
['change_smooth_selection', 'smooth_selection.gif', 'change_smooth_selection_mode'],
['reset_highlight', 'reset_highlight.gif', 'resync_highlight'],
['highlight', 'highlight.gif','change_highlight'],
['help', 'help.gif', 'show_help'],
['save', 'save.gif', 'save'],
['load', 'load.gif', 'load']
];
ua= navigator.userAgent;
this.nav= new Array();
this.nav['isIE'] = (navigator.appName == "Microsoft Internet Explorer");
if(this.nav['isIE']){
this.nav['isIE'] = ua.replace(/^.*?MSIE ([0-9\.]*).*$/, "$1");
if(this.nav['isIE']<6)
this.has_error();
}
if(this.nav['isNS'] = ua.indexOf('Netscape/') != -1){
this.nav['isNS']= ua.substr(ua.indexOf('Netscape/')+9);
if(this.nav['isNS']<8 || !this.nav['isIE'])
this.has_error();
}
if(this.nav['isOpera'] = (ua.indexOf('Opera') != -1)){
this.nav['isOpera']= ua.replace(/^.*?Opera.*?([0-9\.]+).*$/i, "$1");
if(this.nav['isOpera']<9)
this.has_error();
this.nav['isIE']=false;
}
this.nav['isGecko'] = (ua.indexOf('Gecko') != -1);
if(this.nav['isFirefox'] =(ua.indexOf('Firefox') != -1))
this.nav['isFirefox'] = ua.replace(/^.*?Firefox.*?([0-9\.]+).*$/i, "$1");
this.nav['isSafari'] = (ua.indexOf('Safari') != -1);
if(this.nav['isSafari'])
this.has_error();
if(this.nav['isIE']>=6 || this.nav['isOpera']>=9 || this.nav['isFirefox'])
this.nav['isValidBrowser']=true;
else
this.nav['isValidBrowser']=false;
this.set_base_url();
for(var script in this.scripts_to_load){
this.load_script(this.baseURL + this.scripts_to_load[script]+ ".js");
this.waiting_loading[this.scripts_to_load[script]+ ".js"]= false;
}
this.addEvent(window, "load", EditAreaLoader.prototype.window_loaded);
};
EditAreaLoader.prototype.has_error= function(){
this.error= true;
for(var i in EditAreaLoader.prototype){
EditAreaLoader.prototype[i]=function(){};
}
};
EditAreaLoader.prototype.init= function(settings){
if(!settings["id"])
this.has_error();
if(this.error)
return;
for(var i in this.default_settings){
if(typeof(settings[i])=="undefined")
settings[i]=this.default_settings[i]
}
if(settings["browsers"]=="known" && this.nav['isValidBrowser']==false){
return;
}
if(settings["begin_toolbar"].length>0)
settings["toolbar"]= settings["begin_toolbar"] +","+ settings["toolbar"];
if(settings["end_toolbar"].length>0)
settings["toolbar"]= settings["toolbar"] +","+ settings["end_toolbar"];
settings["tab_toolbar"]= settings["toolbar"].replace(/ /g,"").split(",");
this.get_template();
this.load_script(this.baseURL + "langs/"+ settings["language"] + ".js");
if(settings["syntax"].length>0){
settings["syntax"]=settings["syntax"].toLowerCase();
this.load_script(this.baseURL + "reg_syntax/"+ settings["syntax"] + ".js");
}
editAreas[settings["id"]]= {"settings": settings};
editAreas[settings["id"]]["displayed"]=false;
};
EditAreaLoader.prototype.window_loaded= function(){
for( var i in editAreaLoader.waiting_loading){
if(editAreaLoader.waiting_loading[i]!="loaded"){
setTimeout("editAreaLoader.window_loaded();", 100);
return;
}
}
for(var i in editAreas){
if(!editAreaLoader.lang[editAreas[i]["settings"]["language"]] || (editAreas[i]["settings"]["syntax"].length>0 && !editAreaLoader.load_syntax[editAreas[i]["settings"]["syntax"]]) ){
setTimeout("editAreaLoader.window_loaded();", 100);
return;
}
}
editAreaLoader.init_syntax_regexp();
if (document.forms) {
for (var i=0; i<document.forms.length; i++) {
var form = document.forms[i];
form.edit_area_replaced_submit=null;
try {
form.edit_area_replaced_submit = form.onsubmit;
form.onsubmit="";
} catch (e) {
}
editAreaLoader.addEvent(form, "submit", EditAreaLoader.prototype.submit);
editAreaLoader.addEvent(form, "reset", EditAreaLoader.prototype.reset);
}
}
for(var i in editAreas)
{
if(editAreas[i]["settings"]["debug"] || editAreas[i]["settings"]["allow_toogle"])
{
var span= document.createElement("span");
var html="";
if(editAreas[i]["settings"]["allow_toogle"]){
checked=(editAreas[i]["settings"]["display"]=="onload")?"checked":"";
html+="<div id='edit_area_toogle'>";
html+="<input id='edit_area_toogle_checkbox_"+ i +"' class='toogle_"+ i +"' type='checkbox' onclick='editAreaLoader.toogle(\""+ i +"\");' accesskey='e' "+checked+" />";
html+="<label for='edit_area_toogle_checkbox_"+ i +"'>{$toogle}</label></div>";
}
if(editAreas[i]["settings"]["debug"])
html+="<textarea id='edit_area_debug_"+ i +"' style='z-index: 20; width: 100%; height: 120px;overflow: auto; border: solid black 1px;'></textarea><br />";
html= editAreaLoader.translate(html, editAreas[i]["settings"]["language"]);
span.innerHTML= html;
var father= document.getElementById(i).parentNode;
var next= document.getElementById(i).nextSibling;
if(next==null)
father.appendChild(span);
else
father.insertBefore(span, next);
}
if(editAreas[i]["settings"]["display"]=="onload")
editAreaLoader.start(i);
}
};
EditAreaLoader.prototype.start= function(id){
var html_toolbar_content="";
area=editAreas[id];
for(var i=0; i<area["settings"]["tab_toolbar"].length; i++){
html_toolbar_content+= this.get_control_html(area["settings"]["tab_toolbar"][i], area["settings"]["language"]);
}
if(!this.iframe_script){
this.iframe_script="";
for(var i in this.sub_scripts_to_load)
this.iframe_script+='<script language="javascript" type="text/javascript" src="'+ this.baseURL + this.sub_scripts_to_load[i] +'.js"></script>';
}
if(!this.iframe_css){
this.iframe_css="<link href='"+ this.baseURL +"edit_area.css' rel='stylesheet' type='text/css' />";
}
var template= this.template.replace(/\[__BASEURL__\]/g, this.baseURL);
template= template.replace("[__TOOLBAR__]",html_toolbar_content);
template= template.replace("[__TOOLBAR__]",html_toolbar_content);
template= this.translate(template, area["settings"]["language"], "template");
template= template.replace("[__CSSRULES__]", this.iframe_css);
template= template.replace("[__JSCODE__]", this.iframe_script);
area.textarea=document.getElementById(area["settings"]["id"]);
editAreas[area["settings"]["id"]]["textarea"]=area.textarea;
var father= area.textarea.parentNode;
var content= document.createElement("iframe");
content.name= "frame_"+area["settings"]["id"];
content.id= "frame_"+area["settings"]["id"];
content.style.overflow="hidden";
content.style.display="none";
content.style.borderWidth= "0px";
var next= area.textarea.nextSibling;
if(next==null)
father.appendChild(content);
else
father.insertBefore(content, next) ;
var frame=window.frames["frame_"+area["settings"]["id"]];
frame.document.open();
frame.document.write(template);
frame.document.close();
frame.editAreas=editAreas;
frame.area_id= area["settings"]["id"];
frame.document.area_id= area["settings"]["id"];
};
EditAreaLoader.prototype.toogle= function(id, toogle_to){
if((editAreas[id]["displayed"]==true  && toogle_to!="on") || toogle_to=="off"){
this.toogle_off(id);
}else{
this.toogle_on(id);
}
return false;
};
EditAreaLoader.prototype.toogle_off= function(id){
if(window.frames["frame_"+id])
{
var frame=window.frames["frame_"+id];
editAreas[id]["textarea"].wrap = "off";
if (this.nav['isGecko']) {
var n = editAreas[id]["textarea"].cloneNode(false);
n.setAttribute("wrap", "off");
editAreas[id]["textarea"].parentNode.replaceChild(n, editAreas[id]["textarea"]);
editAreas[id]["textarea"]=document.getElementById(id);
}
editAreas[id]["textarea"].value= frame.editArea.textarea.value;
var selStart= frame.editArea.last_selection["selectionStart"];
var selEnd= frame.editArea.last_selection["selectionEnd"];
var scrollTop= frame.document.getElementById("result").scrollTop;
var scrollLeft= frame.document.getElementById("result").scrollLeft;
document.getElementById("frame_"+id).style.display="none";
editAreas[id]["textarea"].style.display="inline";
editAreas[id]["textarea"].focus();
editAreas[id]["textarea"].selectionStart= selStart;
editAreas[id]["textarea"].selectionEnd= selEnd;
if(this.nav['isIE'])
set_IE_selection(editAreas[id]["textarea"]);
editAreas[id]["textarea"].scrollTop= scrollTop;
editAreas[id]["textarea"].scrollLeft= scrollLeft;
editAreas[id]["displayed"]=false;
}
};
EditAreaLoader.prototype.toogle_on= function(id){
if(window.frames["frame_"+id])
{
var frame=window.frames["frame_"+id];
area= window.frames["frame_"+id].editArea;
area.textarea.value= editAreas[id]["textarea"].value;
var selStart= 0;
var selEnd= 0;
var scrollTop= 0;
var scrollLeft= 0;
if(this.nav['isIE'])
get_IE_selection(editAreas[id]["textarea"]);
if(editAreas[id]["textarea"].use_last==true)
{
var selStart= editAreas[id]["textarea"].last_selectionStart;
var selEnd= editAreas[id]["textarea"].last_selectionEnd;
var scrollTop= editAreas[id]["textarea"].last_scrollTop;
var scrollLeft= editAreas[id]["textarea"].last_scrollLeft;
editAreas[id]["textarea"].use_last=false;
}
else
{
try{
var selStart= editAreas[id]["textarea"].selectionStart;
var selEnd= editAreas[id]["textarea"].selectionEnd;
var scrollTop= editAreas[id]["textarea"].scrollTop;
var scrollLeft= editAreas[id]["textarea"].scrollLeft;
}catch(ex){}
}
this.set_editarea_size_from_textarea(id, document.getElementById("frame_"+id));
editAreas[id]["textarea"].style.display="none";
document.getElementById("frame_"+id).style.display="inline";
area.textarea.focus();
area.textarea.textareaFocused=true;
area.update_size();
window.frames["frame_"+id].document.getElementById("result").scrollTop= scrollTop;
window.frames["frame_"+id].document.getElementById("result").scrollLeft= scrollLeft;
area.textarea.selectionStart= selStart;
area.textarea.selectionEnd= selEnd;
if(this.nav['isIE'])
set_IE_selection(area.textarea, document.getElementById("frame_"+id));
editAreas[id]["displayed"]=true;
}
else
{
if(this.nav['isIE'])
get_IE_selection(document.getElementById(id));
document.getElementById(id).last_selectionStart= document.getElementById(id).selectionStart;
document.getElementById(id).last_selectionEnd= document.getElementById(id).selectionEnd;
document.getElementById(id).last_scrollTop= document.getElementById(id).scrollTop;
document.getElementById(id).last_scrollLeft= document.getElementById(id).scrollLeft;
document.getElementById(id).use_last=true;
editAreaLoader.start(id);
}
};
EditAreaLoader.prototype.set_editarea_size_from_textarea= function(id, frame){
var width= document.getElementById(id).offsetWidth;
var height= document.getElementById(id).offsetHeight;
frame.style.width= width+"px";
frame.style.height= height+"px";
};
EditAreaLoader.prototype.set_base_url= function(){
if (!this.baseURL) {
var elements = document.getElementsByTagName('script');
for (var i=0; i<elements.length; i++) {
if (elements[i].src && elements[i].src.indexOf("edit_area_") != -1 ) {
var src = elements[i].src;
src = src.substring(0, src.lastIndexOf('/'));
this.baseURL = src;
this.file_name= elements[i].src.substr(elements[i].src.lastIndexOf("/")+1);
break;
}
}
}
var documentBasePath = document.location.href;
if (documentBasePath.indexOf('?') != -1)
documentBasePath = documentBasePath.substring(0, documentBasePath.indexOf('?'));
var documentURL = documentBasePath;
documentBasePath = documentBasePath.substring(0, documentBasePath.lastIndexOf('/'));
if (this.baseURL.indexOf('://') == -1 && this.baseURL.charAt(0) != '/') {
this.baseURL = documentBasePath + "/" + this.baseURL;
}
this.baseURL+="/";
};
EditAreaLoader.prototype.get_control_html= function(button_name, lang) {
for (var i=0; i<editAreaLoader.advanced_buttons.length; i++)
{
var but = editAreaLoader.advanced_buttons[i];
if (but[0] == button_name)
{
var cmd = 'editArea.execCommand(\'' + but[2] + '\')';
html= '<a href="javascript:' + cmd + '" onclick="' + cmd + ';return false;" onmousedown="return false;" target="_self">';
html+= '<img id="' + but[0] + '_icon" src="'+ this.baseURL +'images/' + but[1] + '" title="' + this.translate(but[0], lang,"word") + '" width="20" height="20" class="editAreaButtonNormal" onmouseover="editArea.switchClass(this,\'editAreaButtonOver\');" onmouseout="editArea.restoreClass(this);" onmousedown="editArea.restoreAndSwitchClass(this,\'editAreaButtonDown\');" /></a>';
return html;
}
}
switch (button_name){
case "|":
case "separator":
return '<img src="'+ this.baseURL +'images/spacer.gif" width="1" height="15" class="editAreaSeparatorLine">';
case "select_font":
html= "<select id='area_font_size' onchange='javascript:editArea.change_font_size()'>"
+"			<option value='-1'>{$font_size}</option>"
+"			<option value='8'>8 pt</option>"
+"			<option value='9'>9 pt</option>"
+"			<option value='10'>10 pt</option>"
+"			<option value='11'>11 pt</option>"
+"			<option value='12'>12 pt</option>"
+"			<option value='14'>14 pt</option>"
+"		</select>";
return html + this.get_control_html("|", lang);
}
return "";
};
EditAreaLoader.prototype.get_template= function() {
if(this.template=="")
{
var xhr_object = null;
if(window.XMLHttpRequest)
xhr_object = new XMLHttpRequest();
else if(window.ActiveXObject)
xhr_object = new ActiveXObject("Microsoft.XMLHTTP");
else {
alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest...");
return;
}
xhr_object.open("GET", this.baseURL+"template.html", false);
xhr_object.send(null);
if(xhr_object.readyState == 4)
this.template=xhr_object.responseText;
else
this.has_error();
}
};
EditAreaLoader.prototype.translate= function(text, lang, mode) {
if(mode=="word")
text=editAreaLoader.get_word_translation(text, lang);
else if(mode="template"){
editAreaLoader.current_language= lang;
text=text.replace(/\{\$([^\}]+)\}/gm, editAreaLoader.translate_template);
}
return text;
};
EditAreaLoader.prototype.translate_template= function(){
return editAreaLoader.get_word_translation(EditAreaLoader.prototype.translate_template.arguments[1], editAreaLoader.current_language);
};
EditAreaLoader.prototype.get_word_translation= function(val, lang){
for(var i in editAreaLoader.lang[lang]){
if(i == val)
return editAreaLoader.lang[lang][i];
}
return "_"+val;
};
EditAreaLoader.prototype.load_script= function(url){
if (this.loadedFiles[url])
return;
try{
script= document.createElement("script");
script.type= "text/javascript";
script.src= url;
head= document.getElementsByTagName("head");
head[0].appendChild(script);
}catch(e){
document.write('<sc'+'ript language="javascript" type="text/javascript" src="' + url + '"></sc'+'ript>');
}
this.loadedFiles[url] = true;
};
EditAreaLoader.prototype.addEvent = function(obj, name, handler) {
if (this.nav['isIE']) {
obj.attachEvent("on" + name, handler);
} else{
obj.addEventListener(name, handler, false);
}
};
EditAreaLoader.prototype.reset= function(e){
var formObj = editAreaLoader.nav['isIE'] ? window.event.srcElement : e.target;
for(var i in editAreas){
if(window.frames["frame_"+i] && isChildOf(document.getElementById(i), formObj)){
var exec= 'window.frames["frame_'+ i +'"].editArea.textarea.value= document.getElementById("'+ i +'").value;';
exec+= 'window.frames["frame_'+ i +'"].editArea.textareaFocused=true;';
exec+= 'window.frames["frame_'+ i +'"].editArea.check_line_selection();';
window.setTimeout(exec, 10);
}
}
return;
};
EditAreaLoader.prototype.submit= function(e){
var formObj = editAreaLoader.nav['isIE'] ? window.event.srcElement : e.target;
for(var i in editAreas){
;
if(isChildOf(document.getElementById(i), formObj)){
document.getElementById(i).value= window.frames["frame_"+ i].editArea.textarea.value;
}
}
if(typeof(formObj.edit_area_replaced_submit) == "function"){
res= formObj.edit_area_replaced_submit();
if(res==false){
if(editAreaLoader.nav['isIE'])
return false;
else
e.preventDefault();
}
}
return ;
};
editAreaLoader= new EditAreaLoader();
editAreas= new Array();
function getAttribute( elm, aname ) {
try{
var avalue = elm.getAttribute( aname );
}catch(exept){
}
if ( ! avalue ) {
for ( var i = 0; i < elm.attributes.length; i ++ ) {
var taName = elm.attributes [i] .name.toLowerCase();
if ( taName == aname ) {
avalue = elm.attributes [i] .value;
return avalue;
}
}
}
return avalue;
};
function setAttribute( elm, attr, val ) {
if(attr=="class"){
elm.setAttribute("className", val);
elm.setAttribute("class", val);
}else{
elm.setAttribute(attr, val);
}
};
function getChildren(elem, elem_type, elem_attribute, elem_attribute_match, option, depth){
if(!option)
var option="single";
if(depth ==null)
var depth=-1;
if(elem){
var children= elem.childNodes;
var result=null;
var results= new Array();
for (var x=0;x<children.length;x++) {
strTagName = new String(children[x].tagName);
children_class="?";
if(strTagName!= "undefined"){
children_class= getAttribute(children[x],elem_attribute);
if((strTagName.toLowerCase()==elem_type.toLowerCase() || elem_type=="") && (elem_attribute=="" ||children_class==elem_attribute_match)){
if(option=="all"){
results.push(children[x]);
}else{
return children[x];
}
}
if(option=="all" && depth!=0){
result=getChildren(children[x], elem_type, elem_attribute, elem_attribute_match, option, depth-1);
if(option=="all"){
if(result.length>0){
results= results.concat(result);
}
}else if(result!=null){
return result;
}
}
}
}
if(option=="all")
return results;
}
return null;
};
function isChildOf(elem, parent){
if(elem){
if(elem==parent)
return true;
while(elem.parentNode != 'undefined'){
return isChildOf(elem.parentNode, parent);
}
}
return false;
};
function getMouseX(e){
if(e!=null && typeof(e.pageX)!="undefined"){
return e.pageX;
}else{
return (e!=null?e.x:event.x)+ document.documentElement.scrollLeft;
}
};
function getMouseY(e){
if(e!=null && typeof(e.pageY)!="undefined"){
return e.pageY;
}else{
return (e!=null?e.y:event.y)+ document.documentElement.scrollTop;
}
};
function calculeOffsetLeft(r){
return calculeOffset(r,"offsetLeft")
};
function calculeOffsetTop(r){
return calculeOffset(r,"offsetTop")
};
function calculeOffset(element,attr){
var offset=0;
while(element){
offset+=element[attr];
element=element.offsetParent
}
return offset;
};
var move_current_element;
function start_move_element(e, id, frame){
var elem_id=(e.target || e.srcElement).id;
if(id)
elem_id=id;
if(!frame)
frame=window;
if(frame.event)
e=frame.event;
move_current_element= frame.document.getElementById(elem_id);
move_current_element.frame=frame;
frame.document.onmousemove= move_element;
frame.document.onmouseup= end_move_element;
mouse_x= getMouseX(e);
mouse_y= getMouseY(e);
move_current_element.start_pos_x = mouse_x - (move_current_element.style.left.replace("px","") || calculeOffsetLeft(move_current_element));
move_current_element.start_pos_y = mouse_y - (move_current_element.style.top.replace("px","") || calculeOffsetTop(move_current_element));
return false;
};
function end_move_element(e){
move_current_element.frame.document.onmousemove= "";
move_current_element.frame.document.onmouseup= "";
move_current_element=null;
};
function move_element(e){
if(move_current_element.frame && move_current_element.frame.event)
e=move_current_element.frame.event;
var mouse_x=getMouseX(e);
var mouse_y=getMouseY(e);
var new_top= mouse_y - move_current_element.start_pos_y;
var new_left= mouse_x - move_current_element.start_pos_x;
move_current_element.style.top= new_top+"px";
move_current_element.style.left= new_left+"px";
return false;
};
function get_IE_selection(textarea){
textarea.focus();
var range = document.selection.createRange();
var stored_range = range.duplicate();
stored_range.moveToElementText( textarea );
stored_range.setEndPoint( 'EndToEnd', range );
if(stored_range.parentElement() != textarea)
return;
var range_start=stored_range.text.length - range.text.length;
textarea.selectionStart = range_start;
var range_end=textarea.selectionStart + range.text.length;
textarea.selectionEnd = range_end;
};
function set_IE_selection(textarea){
var nbLineStart=textarea.value.substr(0, textarea.selectionStart).split("\n").length - 1;
var nbLineEnd=textarea.value.substr(0, textarea.selectionEnd).split("\n").length - 1;
var range = document.selection.createRange();
range.moveToElementText( textarea );
range.setEndPoint( 'EndToStart', range );
range.moveStart('character', textarea.selectionStart - nbLineStart);
range.moveEnd('character', textarea.selectionEnd - nbLineEnd - (textarea.selectionStart - nbLineStart)  );
range.select();
};
function count_children(elem, level){
children= elem.childNodes;
if(!level)
level=0;
if(level==0)
return children.length;
else{
var count= children.length;
for(i in children)
count+= count_children(elem, level-1);
return count;
}
};
function count_child_type(elem, level){
var new_node= elem.cloneNode(false);
var types= new Array();
children= elem.childNodes;
if(children){
error+="\n\t nb child before:"+ elem.childNodes.length;
for(i=0; i< children.length; i++){
if(children[i].nodeType && children[i].nodeType>=1 && children[i].nodeType <= 12 ){
if(types[children[i].nodeType])
types[children[i].nodeType]++;
else
types[children[i].nodeType]=1;
newContent = children[i].cloneNode(true);
new_node.appendChild(newContent);
}else{
error+="\nbad children: ";
new_node.removeChild(children[i]);
}
}
error+= "  nb child after :"+ new_node.childNodes.length+ " level: "+level;
if(!level)
level=0;
if(level!=0){
for(var i=0; i<new_node.childNodes.length; i++){
count_child_type(new_node.childNodes[i], level-1);
}
}
}
document.getElementById("src").value+=error;
elem.parentNode.insertBefore(new_node,elem);
return types;
};
editAreaLoader.waiting_loading["elements_functions.js"]= "loaded";
EditAreaLoader.prototype.start_resize_area= function(){
document.onmouseup= editAreaLoader.end_resize_area;
document.onmousemove= editAreaLoader.resize_area;
editAreaLoader.toogle(editAreaLoader.resize["id"]);
var textarea= editAreas[editAreaLoader.resize["id"]]["textarea"];
var div= document.getElementById("edit_area_resize");
if(!div){
div= document.createElement("div");
div.id="edit_area_resize";
div.style.border="dashed #888888 1px";
}
var width= textarea.offsetWidth -2;
var height= textarea.offsetHeight -2;
div.style.display="block";
div.style.width= width+"px";
div.style.height= height+"px";
var father= textarea.parentNode;
father.insertBefore(div, textarea);
textarea.style.display="none";
editAreaLoader.resize["start_top"]= calculeOffsetTop(div);
editAreaLoader.resize["start_left"]= calculeOffsetLeft(div);
};
EditAreaLoader.prototype.end_resize_area= function(e){
document.onmouseup="";
document.onmousemove="";
var div= document.getElementById("edit_area_resize");
var textarea= editAreas[editAreaLoader.resize["id"]]["textarea"];
var width= Math.max(editAreaLoader.min_area_size["x"], div.offsetWidth-4);
var height= Math.max(editAreaLoader.min_area_size["y"], div.offsetHeight-4);
if(editAreaLoader.nav['isIE']==6){
width-=2;
height-=2;
}
textarea.style.width= width+"px";
textarea.style.height= height+"px";
div.style.display="none";
textarea.style.display="inline";
textarea.selectionStart= editAreaLoader.resize["selectionStart"];
textarea.selectionEnd= editAreaLoader.resize["selectionEnd"];
editAreaLoader.toogle(editAreaLoader.resize["id"]);
return false;
};
EditAreaLoader.prototype.resize_area= function(e){
var allow= editAreas[editAreaLoader.resize["id"]]["settings"]["allow_resize"];
if(allow=="both" || allow=="y")
{
new_y= getMouseY(e);
var new_height= Math.max(20, new_y- editAreaLoader.resize["start_top"]);
document.getElementById("edit_area_resize").style.height= new_height+"px";
}
if(allow=="both" || allow=="x")
{
new_x= getMouseX(e);
var new_width= Math.max(20, new_x- editAreaLoader.resize["start_left"]);
document.getElementById("edit_area_resize").style.width= new_width+"px";
}
return false;
};
editAreaLoader.waiting_loading["resize_area.js"]= "loaded";
EditAreaLoader.prototype.get_regexp= function(text_array){
res="(\\b)(";
for( i=0; i<text_array.length; i++){
if(i>0)
res+="|";
res+=this.get_escaped_regexp(text_array[i]);
}
res+=")(\\b)";
reg= new RegExp(res);
return res;
};
EditAreaLoader.prototype.get_escaped_regexp= function(str){
return str.replace(/(\.|\?|\*|\+|\\|\(|\)|\[|\]|\}|\{|\$|\^)/g, "\\$1");
};
EditAreaLoader.prototype.init_syntax_regexp= function(){
var lang_style= new Array();
for(var lang in this.load_syntax){
this.syntax[lang]= new Array();
this.syntax[lang]["keywords_reg_exp"]= new Array();
this.keywords_reg_exp_nb=0;
if(this.load_syntax[lang]['KEYWORDS']){
for(var i in this.load_syntax[lang]['KEYWORDS']){
this.syntax[lang]["keywords_reg_exp"][i]= new RegExp(this.get_regexp( this.load_syntax[lang]['KEYWORDS'][i] ),"g");
this.keywords_reg_exp_nb++;
}
}
if(this.load_syntax[lang]['OPERATORS']){
var str="";
for(var i in this.load_syntax[lang]['OPERATORS']){
str+=this.load_syntax[lang]['OPERATORS'][i];
}
this.syntax[lang]["operators_reg_exp"]= new RegExp("(["+str+"])","g");
}
if(this.load_syntax[lang]['DELIMITERS']){
var str="";
var nb=0;
for(var i in this.load_syntax[lang]['DELIMITERS']){
if(nb>0)
str+="|";
str+=this.get_escaped_regexp(this.load_syntax[lang]['DELIMITERS'][i]);
nb++;
}
this.syntax[lang]["delimiters_reg_exp"]= new RegExp("("+str+")","g");
}
var syntax_trace=new Array();
this.syntax[lang]["quotes"]=new Array();
var quote_tab= new Array();
if(this.load_syntax[lang]['QUOTEMARKS']){
for(var i in this.load_syntax[lang]['QUOTEMARKS']){
var x=this.get_escaped_regexp(this.load_syntax[lang]['QUOTEMARKS'][i]);
this.syntax[lang]["quotes"][x]=x;
quote_tab[quote_tab.length]="("+x+"(\\\\"+x+"|[^"+x+"])*("+x+"|$))";
syntax_trace.push(x);
}
}
this.syntax[lang]["comments"]=new Array();
if(this.load_syntax[lang]['COMMENT_SINGLE']){
for(var i in this.load_syntax[lang]['COMMENT_SINGLE']){
var x=this.get_escaped_regexp(this.load_syntax[lang]['COMMENT_SINGLE'][i]);
quote_tab[quote_tab.length]="("+x+"(.|\\r|\\t)*(\\n|$))";
syntax_trace.push(x);
this.syntax[lang]["comments"][x]="\n";
}
}
// (/\*(.|[\r\n])*?\*/)
if(this.load_syntax[lang]['COMMENT_MULTI']){
for(var i in this.load_syntax[lang]['COMMENT_MULTI']){
var start=this.get_escaped_regexp(i);
var end=this.get_escaped_regexp(this.load_syntax[lang]['COMMENT_MULTI'][i]);
quote_tab[quote_tab.length]="("+start+"(.|\\n|\\r)*?("+end+"|$))";
syntax_trace.push(start);
syntax_trace.push(end);
this.syntax[lang]["comments"][i]=this.load_syntax[lang]['COMMENT_MULTI'][i];
}
}
if(quote_tab.length>0)
this.syntax[lang]["comment_or_quote_reg_exp"]= new RegExp("("+quote_tab.join("|")+")","gi");
if(syntax_trace.length>0) //   /((.|\n)*?)(\\*("|'|\/\*|\*\/|\/\/|$))/g
this.syntax[lang]["syntax_trace_regexp"]= new RegExp("((.|\n)*?)(\\\\*("+ syntax_trace.join("|") +"|$))", "gmi");
if(this.load_syntax[lang]['SCRIPT_DELIMITERS']){
this.syntax[lang]["script_delimiters"]= new Array();
for(var i in this.load_syntax[lang]['SCRIPT_DELIMITERS']){
this.syntax[lang]["script_delimiters"][i]= this.load_syntax[lang]['SCRIPT_DELIMITERS'];
}
}
this.syntax[lang]["custom_regexp"]= new Array();
if(this.load_syntax[lang]['REGEXPS']){
for(var i in this.load_syntax[lang]['REGEXPS']){
var val= this.load_syntax[lang]['REGEXPS'][i];
if(!this.syntax[lang]["custom_regexp"][val['execute']])
this.syntax[lang]["custom_regexp"][val['execute']]= new Array();
this.syntax[lang]["custom_regexp"][val['execute']][i]={'regexp' : new RegExp(val['search'], val['modifiers'])
, 'class' : val['class']};
}
}
if(this.load_syntax[lang]['STYLES']){
lang_style[lang]= new Array();
for(var i in this.load_syntax[lang]['STYLES']){
if(typeof(this.load_syntax[lang]['STYLES'][i]) != "string"){
for(var j in this.load_syntax[lang]['STYLES'][i]){
lang_style[lang][j]= this.load_syntax[lang]['STYLES'][i][j];
}
}else{
lang_style[lang][i]= this.load_syntax[lang]['STYLES'][i];
}
}
}
// build style string
var style="";
for(var i in lang_style[lang]){
style+= "."+ i.toLowerCase() +" span{"+lang_style[lang][i]+"}\n";
style+= "."+ i.toLowerCase() +"{"+lang_style[lang][i]+"}\n";
}
this.syntax[lang]["styles"]=style;
}
};
editAreaLoader.waiting_loading["reg_syntax.js"]= "loaded";

editAreaLoader.iframe_script= "<script language='Javascript' type='text/javascript'>\n"
+"function EditArea(){\n"
+"this.error= false;\n"
+"this.inlinePopup= new Array({popup_id: \"area_search_replace\", icon_id: \"search_icon\"},\n"
+"{popup_id: \"edit_area_help\", icon_id: \"help_icon\"});\n"
+"this.line_number=0;\n"
+"this.nav=parent.editAreaLoader.nav;\n"
+"this.last_selection=new Array();\n"
+"this.last_text_to_highlight=\"\";\n"
+"this.last_hightlighted_text= \"\";\n"
+"this.textareaFocused= false;\n"
+"this.previous= new Array();\n"
+"this.next= new Array();\n"
+"this.assocBracket=new Array();\n"
+"this.revertAssocBracket= new Array();\n"
+"this.assocBracket[\"(\"]=\")\";\n"
+"this.assocBracket[\"{\"]=\"}\";\n"
+"this.assocBracket[\"[\"]=\"]\";\n"
+"for(var index in this.assocBracket){\n"
+"this.revertAssocBracket[this.assocBracket[index]]=index;\n"
+"}\n"
+"this.lineHeight= 16;\n"
+"this.charWidth=8;\n"
+"this.tab_nb_char= 8;\n"
+"if(this.nav['isOpera'])\n"
+"this.tab_nb_char= 6;\n"
+"this.is_tabbing= false;\n"
+"this.isResizing=false;\n"
+"};\n"
+"EditArea.prototype.update_size= function(){\n"
+"toolbar_height= document.body.offsetHeight - this.get_all_toolbar_height() - 4;\n"
+"document.getElementById(\"result\").style.height= toolbar_height +\"px\";\n"
+"width=document.body.offsetWidth -2;\n"
+"document.getElementById(\"result\").style.width= width+\"px\";\n"
+"};\n"
+"EditArea.prototype.init= function(){\n"
+"this.id= area_id;\n"
+"this.settings= editAreas[this.id][\"settings\"];\n"
+"this.textarea= document.getElementById(\"textarea\");\n"
+"this.textarea.value=editAreas[this.id][\"textarea\"].value;\n"
+"if(this.settings[\"debug\"])\n"
+"this.debug=parent.document.getElementById(\"edit_area_debug_\"+this.id);\n"
+"if(document.getElementById(\"redo_icon\") != null)\n"
+"this.switchClassSticky(document.getElementById(\"redo_icon\"), 'editAreaButtonDisabled', true);\n"
+"if(typeof(parent.editAreaLoader.syntax[this.settings[\"syntax\"]])!=\"undefined\"){\n"
+"var styles=parent.editAreaLoader.syntax[this.settings[\"syntax\"]][\"styles\"];\n"
+"if(styles.length>0){\n"
+"if(document.createStyleSheet){\n"
+"document.createStyleSheet(\"javascript:'\"+styles+\"'\");\n"
+"}else{\n"
+"newSS= document.createElement('link');\n"
+"newSS.rel= 'stylesheet';\n"
+"newSS.href= 'data:text/css,'+escape(styles);\n"
+"document.getElementsByTagName(\"head\")[0].appendChild(newSS);\n"
+"}\n"
+"}\n"
+"}\n"
+"if(this.nav['isOpera'])\n"
+"document.getElementById(\"editor\").onkeypress= keyDown;\n"
+"else\n"
+"document.getElementById(\"editor\").onkeydown= keyDown;\n"
+"for(var i in this.inlinePopup){\n"
+"if(this.nav['isIE'] || this.nav['isFirefox'])\n"
+"document.getElementById(this.inlinePopup[i][\"popup_id\"]).onkeydown= keyDown;\n"
+"else\n"
+"document.getElementById(this.inlinePopup[i][\"popup_id\"]).onkeypress= keyDown;\n"
+"}\n"
+"if(this.settings[\"allow_resize\"]!=\"no\")\n"
+"{\n"
+"document.getElementById(\"resize_area\").style.visibility=\"visible\";\n"
+"document.getElementById(\"resize_area\").onmouseup= editArea.start_resize;\n"
+"}\n"
+"parent.editAreaLoader.toogle(this.id, \"on\");\n"
+"this.change_smooth_selection_mode(editArea.smooth_selection);\n"
+"this.change_highlight(this.settings[\"start_highlight\"]);\n"
+"this.set_font(editArea.settings[\"font_family\"], editArea.settings[\"font_size\"]);\n"
+"children= parent.getChildren(document.body, \"\", \"selec\", \"none\", \"all\", -1);\n"
+"for(var i in children){\n"
+"if(this.nav['isIE'])\n"
+"children[i].unselectable = true;\n"
+"else\n"
+"children[i].onmousedown= function(){return false};\n"
+"}\n"
+"if(this.nav['isOpera']){\n"
+"document.getElementById(\"editor\").style.position= \"absolute\";\n"
+"document.getElementById(\"selection_field\").style.marginTop= \"-1pt\";\n"
+"document.getElementById(\"selection_field\").style.paddingTop= \"1pt\";\n"
+"document.getElementById(\"cursor_pos\").style.marginTop= \"-1pt\";\n"
+"document.getElementById(\"end_bracket\").style.marginTop= \"-1pt\";\n"
+"document.getElementById(\"content_highlight\").style.marginTop= \"-1pt\";\n"
+"}\n"
+"if(this.nav['isIE']>=7){\n"
+"}\n"
+"setTimeout(\"editArea.manage_size();\", 10);\n"
+"this.check_undo();\n"
+"this.check_line_selection(true);\n"
+"this.scroll_to_view();\n"
+"};\n"
+"EditArea.prototype.manage_size= function(){\n"
+"if(editAreas[this.id][\"displayed\"]==true)\n"
+"{\n"
+"var resized= false;\n"
+"area_width= this.textarea.scrollWidth;\n"
+"area_height= this.textarea.scrollHeight;\n"
+"if(this.nav['isOpera']){\n"
+"area_height= this.last_selection['nb_line']*this.lineHeight;\n"
+"area_width=10000;\n"
+"}\n"
+"if(this.nav['isIE']==7)\n"
+"area_width-=45;\n"
+"if(this.nav['isGecko'] && this.smooth_selection && this.last_selection[\"nb_line\"])\n"
+"area_height= this.last_selection[\"nb_line\"]*this.lineHeight;\n"
+"if(this.last_selection[\"nb_line\"] >= this.line_number)\n"
+"{\n"
+"var div_line_number=\"\";\n"
+"for(i=this.line_number+1; i<this.last_selection[\"nb_line\"]+100; i++)\n"
+"{\n"
+"div_line_number+=i+\"<br />\";\n"
+"this.line_number++;\n"
+"}\n"
+"var span= document.createElement(\"span\");\n"
+"if(this.nav['isIE'])\n"
+"span.unselectable=true;\n"
+"span.innerHTML=div_line_number;\n"
+"document.getElementById(\"line_number\").appendChild(span);\n"
+"}\n"
+"if(this.textarea.previous_scrollWidth!=area_width)\n"
+"{\n"
+"if(this.nav['isOpera']){\n"
+"}else{\n"
+"if(this.textarea.style.width.replace(\"px\",\"\") < area_width){\n"
+"area_width+=50;\n"
+"}\n"
+"}\n"
+"if(this.nav['isGecko'] || this.nav['isOpera'])\n"
+"document.getElementById(\"container\").style.width= (area_width+45)+\"px\";\n"
+"else\n"
+"document.getElementById(\"container\").style.width= area_width+\"px\";\n"
+"document.getElementById(\"textarea\").style.width= area_width+\"px\";\n"
+"document.getElementById(\"content_highlight\").style.width= area_width+\"px\";\n"
+"this.textarea.previous_scrollWidth=area_width;\n"
+"resized=true;\n"
+"}\n"
+"if(this.textarea.previous_scrollHeight!=area_height)\n"
+"{\n"
+"document.getElementById(\"container\").style.height= (area_height+2)+\"px\";\n"
+"document.getElementById(\"textarea\").style.height= area_height+\"px\";\n"
+"document.getElementById(\"content_highlight\").style.height= area_height+\"px\";\n"
+"this.textarea.previous_scrollHeight=area_height;\n"
+"resized=true;\n"
+"}\n"
+"this.textarea.scrollTop=\"0px\";\n"
+"this.textarea.scrollLeft=\"0px\";\n"
+"if(resized==true){\n"
+"this.scroll_to_view();\n"
+"}\n"
+"}\n"
+"setTimeout(\"editArea.manage_size();\", 100);\n"
+"};\n"
+"EditArea.prototype.addEvent = function(obj, name, handler) {\n"
+"if (this.nav['isIE']) {\n"
+"obj.attachEvent(\"on\" + name, handler);\n"
+"} else{\n"
+"obj.addEventListener(name, handler, false);\n"
+"}\n"
+"};\n"
+"EditArea.prototype.execCommand= function(cmd){\n"
+"switch(cmd){\n"
+"case \"save\":\n"
+"if(this.settings[\"save_callback\"].length>0)\n"
+"eval(\"parent.\"+this.settings[\"save_callback\"]+\"(editArea.textarea.value);\");\n"
+"break;\n"
+"case \"load\":\n"
+"if(this.settings[\"load_callback\"].length>0)\n"
+"eval(\"parent.\"+this.settings[\"load_callback\"]+\"(editArea.textarea);\");\n"
+"break;\n"
+"case \"re_sync\":\n"
+"if(!this.do_highlight)\n"
+"break;\n"
+"default:\n"
+"eval(\"editArea.\"+cmd+\"();\");\n"
+"}\n"
+"};\n"
+"EditArea.prototype.get_translation= function(word){\n"
+"return parent.editAreaLoader.get_word_translation(word, this.settings[\"language\"]);\n"
+"};\n"
+"var editArea = new EditArea();\n"
+"editArea.addEvent(window, \"load\", init);\n"
+"function init(){\n"
+"setTimeout(\"editArea.init();  \", 10);\n"
+"};\n"
+"	EditArea.prototype.check_line_selection= function(timer_checkup){\n"
+"if(!this.smooth_selection && !this.do_highlight){\n"
+"}else if(this.textareaFocused && editAreas[this.id][\"displayed\"]==true && this.isResizing==false){\n"
+"infos= this.get_selection_infos();\n"
+"if(this.last_selection[\"line_start\"] != infos[\"line_start\"] || this.last_selection[\"line_nb\"] != infos[\"line_nb\"] || infos[\"full_text\"] != this.last_selection[\"full_text\"] || this.reload_highlight){\n"
+"new_top=this.lineHeight * (infos[\"line_start\"]-1);\n"
+"new_height=Math.max(0, this.lineHeight * infos[\"line_nb\"]);\n"
+"new_width=Math.max(this.textarea.scrollWidth, document.getElementById(\"container\").clientWidth -50);\n"
+"document.getElementById(\"selection_field\").style.top=new_top+\"px\";\n"
+"document.getElementById(\"selection_field\").style.width=new_width+\"px\";\n"
+"document.getElementById(\"selection_field\").style.height=new_height+\"px\";\n"
+"document.getElementById(\"cursor_pos\").style.top=new_top+\"px\";\n"
+"if(this.do_highlight==true){\n"
+"var curr_text=infos[\"full_text\"].split(\"\\n\");\n"
+"var content=\"\";\n"
+"var start=Math.max(0,infos[\"line_start\"]-1)\n"
+"var end=Math.min(curr_text.length, infos[\"line_start\"]+infos[\"line_nb\"]-1);\n"
+"for(i=start; i< end; i++){\n"
+"new_line= curr_text[i];\n"
+"if(this.nav['isOpera'])\n"
+"new_line= this.replace_tab(new_line);\n"
+"new_line= new_line.replace(/&/g,\"&amp;\");\n"
+"new_line= new_line.replace(/</g,\"&lt;\");\n"
+"new_line= new_line.replace(/>/g,\"&gt;\");\n"
+"content+=new_line+\"\\n\";\n"
+"}\n"
+"if(this.nav['isIE'])\n"
+"document.getElementById(\"selection_field\").innerHTML= \"<pre>\" + content.replace(\"\\n\", \"<br/>\") + \"</pre>\";\n"
+"else\n"
+"document.getElementById(\"selection_field\").innerHTML=content;\n"
+"if(this.reload_highlight || (infos[\"full_text\"] != this.last_text_to_highlight && (this.last_selection[\"line_start\"]!=infos[\"line_start\"] || this.last_selection[\"line_nb\"]!=infos[\"line_nb\"] || this.last_selection[\"nb_line\"]!=infos[\"nb_line\"]) ) )\n"
+"this.maj_highlight(infos);\n"
+"}\n"
+"}\n"
+"if(infos[\"line_start\"] != this.last_selection[\"line_start\"] || infos[\"curr_pos\"] != this.last_selection[\"curr_pos\"]){\n"
+"var selec_char= infos[\"curr_line\"].charAt(infos[\"curr_pos\"]-1);\n"
+"var no_real_move=true;\n"
+"if(infos[\"line_nb\"]==1 && (this.assocBracket[selec_char] || this.revertAssocBracket[selec_char]) ){\n"
+"no_real_move=false;\n"
+"if(this.findEndBracket(infos, selec_char) === true){\n"
+"document.getElementById(\"end_bracket\").style.visibility=\"visible\";\n"
+"document.getElementById(\"cursor_pos\").style.visibility=\"visible\";\n"
+"document.getElementById(\"cursor_pos\").innerHTML= selec_char;\n"
+"document.getElementById(\"end_bracket\").innerHTML= (this.assocBracket[selec_char] || this.revertAssocBracket[selec_char]);\n"
+"}else{\n"
+"document.getElementById(\"end_bracket\").style.visibility=\"hidden\";\n"
+"document.getElementById(\"cursor_pos\").style.visibility=\"hidden\";\n"
+"}\n"
+"}else{\n"
+"document.getElementById(\"cursor_pos\").style.visibility=\"hidden\";\n"
+"document.getElementById(\"end_bracket\").style.visibility=\"hidden\";\n"
+"}\n"
+"this.displayToCursorPosition(\"cursor_pos\", infos[\"line_start\"], infos[\"curr_pos\"]-1, infos[\"curr_line\"], no_real_move);\n"
+"if(infos[\"line_nb\"]==1)\n"
+"this.scroll_to_view();\n"
+"}\n"
+"this.last_selection=infos;\n"
+"}\n"
+"if(timer_checkup){\n"
+"if(this.do_highlight==true)\n"
+"setTimeout(\"editArea.check_line_selection(true)\", 50);\n"
+"else\n"
+"setTimeout(\"editArea.check_line_selection(true)\", 50);\n"
+"}\n"
+"};\n"
+"EditArea.prototype.get_selection_infos= function(){\n"
+"var selections=new Array();\n"
+"selections[\"selectionStart\"]= this.textarea.selectionStart;\n"
+"selections[\"selectionEnd\"]= this.textarea.selectionEnd;\n"
+"selections[\"full_text\"]= this.textarea.value;\n"
+"selections[\"line_start\"]=1;\n"
+"selections[\"line_nb\"]=1;\n"
+"selections[\"curr_pos\"]=0;\n"
+"selections[\"curr_line\"]=\"\";\n"
+"selections[\"indexOfCursor\"]=0;\n"
+"selections[\"selec_direction\"]= this.last_selection[\"selec_direction\"];\n"
+"var splitTab=selections[\"full_text\"].split(\"\\n\");\n"
+"var nbLine=Math.max(0, splitTab.length);\n"
+"var nbChar=Math.max(0, selections[\"full_text\"].length - (nbLine - 1));\n"
+"if(this.nav['isIE'])\n"
+"nbChar= nbChar - (nbLine -1);\n"
+"selections[\"nb_line\"]=nbLine;\n"
+"selections[\"nb_char\"]=nbChar;\n"
+"if(this.nav['isIE'])\n"
+"this.getIESelection();\n"
+"start=this.textarea.selectionStart;\n"
+"end=this.textarea.selectionEnd;\n"
+"if(start>0){\n"
+"var str=selections[\"full_text\"].substr(0,start);\n"
+"selections[\"curr_pos\"]=str.length - str.lastIndexOf(\"\\n\");\n"
+"selections[\"line_start\"]=Math.max(1, str.split(\"\\n\").length);\n"
+"}else{\n"
+"selections[\"curr_pos\"]=1;\n"
+"}\n"
+"if(end>start){\n"
+"selections[\"line_nb\"]=selections[\"full_text\"].substring(start,end).split(\"\\n\").length;\n"
+"}\n"
+"selections[\"indexOfCursor\"]=this.textarea.selectionStart;\n"
+"selections[\"curr_line\"]=splitTab[Math.max(0,selections[\"line_start\"]-1)];\n"
+"if(selections[\"selectionStart\"]==this.last_selection[\"selectionStart\"]){\n"
+"if(selections[\"selectionEnd\"]>this.last_selection[\"selectionEnd\"])\n"
+"selections[\"selec_direction\"]= \"down\";\n"
+"else if(selections[\"selectionEnd\"] == this.last_selection[\"selectionStart\"])\n"
+"selections[\"selec_direction\"]= this.last_selection[\"selec_direction\"];\n"
+"}else if(selections[\"selectionStart\"] == this.last_selection[\"selectionEnd\"] && selections[\"selectionEnd\"]>this.last_selection[\"selectionEnd\"]){\n"
+"selections[\"selec_direction\"]= \"down\";\n"
+"}else{\n"
+"selections[\"selec_direction\"]= \"up\";\n"
+"}\n"
+"document.getElementById(\"nbLine\").innerHTML= nbLine;\n"
+"document.getElementById(\"nbChar\").innerHTML= nbChar;\n"
+"document.getElementById(\"linePos\").innerHTML=selections[\"line_start\"];\n"
+"document.getElementById(\"currPos\").innerHTML=selections[\"curr_pos\"];\n"
+"return selections;\n"
+"};\n"
+"EditArea.prototype.getIESelection= function(){\n"
+"var range = document.selection.createRange();\n"
+"var stored_range = range.duplicate();\n"
+"stored_range.moveToElementText( this.textarea );\n"
+"stored_range.setEndPoint( 'EndToEnd', range );\n"
+"if(stored_range.parentElement() !=this.textarea)\n"
+"return;\n"
+"var scrollTop=document.getElementById(\"result\").scrollTop + document.body.scrollTop;\n"
+"var relative_top= range.offsetTop - parent.calculeOffsetTop(this.textarea) + scrollTop;\n"
+"var line_start = Math.round((relative_top / this.lineHeight) +1);\n"
+"var line_nb=Math.round(range.boundingHeight / this.lineHeight);\n"
+"var range_start=stored_range.text.length - range.text.length;\n"
+"var tab=this.textarea.value.substr(0, range_start).split(\"\\n\");\n"
+"range_start+= (line_start - tab.length)*2;\n"
+"this.textarea.selectionStart = range_start;\n"
+"var range_end=this.textarea.selectionStart + range.text.length;\n"
+"tab=this.textarea.value.substr(0, range_start + range.text.length).split(\"\\n\");\n"
+"range_end+= (line_start + line_nb - 1 - tab.length)*2;\n"
+"this.textarea.selectionEnd = range_end;\n"
+"};\n"
+"EditArea.prototype.setIESelection= function(){\n"
+"var nbLineStart=this.textarea.value.substr(0, this.textarea.selectionStart).split(\"\\n\").length - 1;\n"
+"var nbLineEnd=this.textarea.value.substr(0, this.textarea.selectionEnd).split(\"\\n\").length - 1;\n"
+"var range = document.selection.createRange();\n"
+"range.moveToElementText( this.textarea );\n"
+"range.setEndPoint( 'EndToStart', range );\n"
+"range.moveStart('character', this.textarea.selectionStart - nbLineStart);\n"
+"range.moveEnd('character', this.textarea.selectionEnd - nbLineEnd - (this.textarea.selectionStart - nbLineStart)  );\n"
+"range.select();\n"
+"};\n"
+"EditArea.prototype.tab_selection= function(){\n"
+"if(this.is_tabbing)\n"
+"return;\n"
+"this.is_tabbing=true;\n"
+"if( this.nav['isIE'] )\n"
+"this.getIESelection();\n"
+"var start = this.textarea.selectionStart;\n"
+"var end = this.textarea.selectionEnd;\n"
+"var insText = this.textarea.value.substring(start, end);\n"
+"var pos_start=0;\n"
+"var pos_end=0;\n"
+"if (insText.length == 0) {\n"
+"this.textarea.value = this.textarea.value.substr(0, start) + \"\t\" + insText + this.textarea.value.substr(end);\n"
+"pos_start = start + 1;\n"
+"pos_end=pos_start;\n"
+"} else {\n"
+"start= Math.max(0, this.textarea.value.substr(0, start).lastIndexOf(\"\\n\")+1);\n"
+"endText=this.textarea.value.substr(end);\n"
+"startText=this.textarea.value.substr(0, start);\n"
+"tmp= this.textarea.value.substring(start, end).split(\"\\n\");\n"
+"insText= \"\t\"+tmp.join(\"\\n\t\");\n"
+"this.textarea.value = startText + insText + endText;\n"
+"pos_start = start;\n"
+"pos_end= this.textarea.value.indexOf(\"\\n\", startText.length + insText.length);\n"
+"if(pos_end==-1)\n"
+"pos_end=this.textarea.value.length;\n"
+"}\n"
+"this.textarea.selectionStart = pos_start;\n"
+"this.textarea.selectionEnd = pos_end;\n"
+"if(this.nav['isIE']){\n"
+"this.setIESelection();\n"
+"setTimeout(\"editArea.is_tabbing=false;\", 100);\n"
+"}else\n"
+"this.is_tabbing=false;\n"
+"};\n"
+"EditArea.prototype.invert_tab_selection= function(){\n"
+"if(this.is_tabbing)\n"
+"return;\n"
+"this.is_tabbing=true;\n"
+"if(this.nav['isIE'])\n"
+"this.getIESelection();\n"
+"var start = this.textarea.selectionStart;\n"
+"var end = this.textarea.selectionEnd;\n"
+"var insText = this.textarea.value.substring(start, end);\n"
+"var pos_start=0;\n"
+"var pos_end=0;\n"
+"if (insText.length == 0) {\n"
+"this.textarea.value = this.textarea.value.substr(0, start) + \"\t\" + insText + this.textarea.value.substr(end);\n"
+"pos_start = start + 1;\n"
+"pos_end=pos_start;\n"
+"} else {\n"
+"start= this.textarea.value.substr(0, start).lastIndexOf(\"\\n\")+1;\n"
+"endText=this.textarea.value.substr(end);\n"
+"startText=this.textarea.value.substr(0, start);\n"
+"tmp= this.textarea.value.substring(start, end).split(\"\\n\");\n"
+"insText=\"\";\n"
+"for(i=0; i<tmp.length; i++){\n"
+"for(j=0; j<this.tab_nb_char; j++){\n"
+"if(tmp[i].charAt(0)==\"\t\"){\n"
+"tmp[i]=tmp[i].substr(1);\n"
+"j=this.tab_nb_char;\n"
+"}else if(tmp[i].charAt(0)==\" \")\n"
+"tmp[i]=tmp[i].substr(1);\n"
+"}\n"
+"insText+=tmp[i];\n"
+"if(i<tmp.length-1)\n"
+"insText+=\"\\n\";\n"
+"}\n"
+"this.textarea.value = startText + insText + endText;\n"
+"pos_start = start;\n"
+"pos_end= this.textarea.value.indexOf(\"\\n\", startText.length + insText.length);\n"
+"if(pos_end==-1)\n"
+"pos_end=this.textarea.value.length;\n"
+"}\n"
+"this.textarea.selectionStart = pos_start;\n"
+"this.textarea.selectionEnd = pos_end;\n"
+"if(this.nav['isIE']){\n"
+"this.setIESelection();\n"
+"setTimeout(\"editArea.is_tabbing=false;\", 100);\n"
+"}else\n"
+"this.is_tabbing=false;\n"
+"};\n"
+"EditArea.prototype.press_enter= function(){\n"
+"if(!this.smooth_selection)\n"
+"return false;\n"
+"if(this.nav['isIE'])\n"
+"this.getIESelection();\n"
+"var start=this.textarea.selectionStart;\n"
+"var end= this.textarea.selectionEnd;\n"
+"var start_last_line= Math.max(0 , this.textarea.value.substring(0, start).lastIndexOf(\"\\n\") + 1 );\n"
+"var begin_line= this.textarea.value.substring(start_last_line, start).replace(/^([ \t]*).*/gm, \"$1\");\n"
+"if(begin_line==\"\\n\" || begin_line==\"\\r\" || begin_line.length==0)\n"
+"return false;\n"
+"if(this.nav['isIE'] || this.nav['isOpera']){\n"
+"begin_line=\"\\r\\n\"+ begin_line;\n"
+"}else{\n"
+"begin_line=\"\\n\"+ begin_line;\n"
+"}\n"
+"this.textarea.value= this.textarea.value.substring(0, start) + begin_line + this.textarea.value.substring(end);\n"
+"this.area_select(start+ begin_line.length ,0);\n"
+"return true;\n"
+"};\n"
+"EditArea.prototype.findEndBracket= function(infos, bracket){\n"
+"var start=infos[\"indexOfCursor\"];\n"
+"var normal_order=true;\n"
+"if(this.assocBracket[bracket])\n"
+"endBracket=this.assocBracket[bracket];\n"
+"else if(this.revertAssocBracket[bracket]){\n"
+"endBracket=this.revertAssocBracket[bracket];\n"
+"normal_order=false;\n"
+"}\n"
+"var end=-1;\n"
+"var nbBracketOpen=0;\n"
+"for(var i=start; i<infos[\"full_text\"].length && i>=0; ){\n"
+"if(infos[\"full_text\"].charAt(i)==endBracket){\n"
+"nbBracketOpen--;\n"
+"if(nbBracketOpen<=0){\n"
+"end=i;\n"
+"break;\n"
+"}\n"
+"}else if(infos[\"full_text\"].charAt(i)==bracket)\n"
+"nbBracketOpen++;\n"
+"if(normal_order)\n"
+"i++;\n"
+"else\n"
+"i--;\n"
+"}\n"
+"if(end==-1)\n"
+"return false;\n"
+"var endLastLine=infos[\"full_text\"].substr(0, end).lastIndexOf(\"\\n\");\n"
+"if(endLastLine==-1)\n"
+"line=1;\n"
+"else\n"
+"line= infos[\"full_text\"].substr(0, endLastLine).split(\"\\n\").length + 1;\n"
+"var curPos= end - endLastLine;\n"
+"this.displayToCursorPosition(\"end_bracket\", line, curPos, infos[\"full_text\"].substring(endLastLine +1, end));\n"
+"return true;\n"
+"};\n"
+"EditArea.prototype.displayToCursorPosition= function(id, start_line, cur_pos, lineContent, no_real_move){\n"
+"var elem=document.getElementById(id);\n"
+"if(this.nav['isIE'])\n"
+"{\n"
+"elem= document.getElementById(\"test_font_size\");\n"
+"elem.innerHTML=\"<pre>\"+lineContent.substr(0, cur_pos).replace(/</g,\"&lt;\")+\"</pre>\";\n"
+"var posLeft= 45 + elem.offsetWidth;\n"
+"}else{\n"
+"var posLeft= 45 + this.replace_tab(lineContent.substr(0, cur_pos)).length* this.charWidth;\n"
+"}\n"
+"var posTop=this.lineHeight * (start_line-1);\n"
+"if(this.settings[\"debug\"]){\n"
+"}\n"
+"if(no_real_move!=true){\n"
+"document.getElementById(id).style.top=posTop+\"px\";\n"
+"document.getElementById(id).style.left=posLeft+\"px\";\n"
+"}\n"
+"document.getElementById(id).cursor_top=posTop;\n"
+"document.getElementById(id).cursor_left=posLeft;\n"
+"};\n"
+"EditArea.prototype.area_select= function(start, length){\n"
+"this.textarea.focus();\n"
+"start= Math.max(0, Math.min(this.textarea.value.length, start));\n"
+"end= Math.max(start, Math.min(this.textarea.value.length, start+length));\n"
+"if(this.nav['isOpera'] && (start < this.textarea.selectionStart || end > this.textarea.selectionEnd)){\n"
+"this.textarea.selectionEnd = 1;\n"
+"this.textarea.selectionStart = 0;\n"
+"this.textarea.selectionEnd = 1;\n"
+"this.textarea.selectionStart = 0;\n"
+"}\n"
+"this.textarea.selectionStart = start;\n"
+"this.textarea.selectionEnd = end;\n"
+"if(this.nav['isIE'])\n"
+"this.setIESelection();\n"
+"};\n"
+"EditArea.prototype.area_get_selection= function(){\n"
+"var text=\"\";\n"
+"if( document.selection ){\n"
+"var range = document.selection.createRange();\n"
+"text=range.text;\n"
+"}else{\n"
+"text= this.textarea.value.substring(this.textarea.selectionStart, this.textarea.selectionEnd);\n"
+"}\n"
+"return text;\n"
+"};\n"
+"\n"
+"EditArea.prototype.replace_tab= function(text){\n"
+"return text.replace(/((\\n?)([^\t\\n]*)\t)/gi, editArea.smartTab);\n"
+"};\n"
+"EditArea.prototype.smartTab= function(){\n"
+"val=\"                   \";\n"
+"return EditArea.prototype.smartTab.arguments[2] + EditArea.prototype.smartTab.arguments[3] + val.substr(0, editArea.tab_nb_char - (EditArea.prototype.smartTab.arguments[3].length)%editArea.tab_nb_char);\n"
+"};\n"
+"EditArea.prototype.set_font= function(family, size){\n"
+"var elems= new Array(\"textarea\", \"content_highlight\", \"cursor_pos\", \"end_bracket\", \"selection_field\", \"line_number\");\n"
+"if(family && family!=\"\")\n"
+"this.settings[\"font_family\"]= family;\n"
+"if(size && size>0)\n"
+"this.settings[\"font_size\"]=size;\n"
+"var elem_font=document.getElementById(\"area_font_size\");\n"
+"if(elem_font){\n"
+"for(var i=0; i < elem_font.length; i++){\n"
+"if(elem_font.options[i].value && elem_font.options[i].value == this.settings[\"font_size\"])\n"
+"elem_font.options[i].selected=true;\n"
+"}\n"
+"}\n"
+"document.getElementById(\"test_font_size\").style.fontFamily= \"\"+this.settings[\"font_family\"];\n"
+"document.getElementById(\"test_font_size\").style.fontSize= this.settings[\"font_size\"]+\"pt\";\n"
+"document.getElementById(\"test_font_size\").innerHTML=\"0\";\n"
+"this.charWidth= document.getElementById('test_font_size').offsetWidth;\n"
+"this.lineHeight= document.getElementById(\"test_font_size\").offsetHeight;\n"
+"for( var i in elems){\n"
+"var elem=	document.getElementById(elems[i]);\n"
+"document.getElementById(elems[i]).style.fontFamily= \"\"+this.settings[\"font_family\"];\n"
+"document.getElementById(elems[i]).style.fontSize= this.settings[\"font_size\"]+\"pt\";\n"
+"document.getElementById(elems[i]).style.lineHeight= this.lineHeight+\"px\";\n"
+"}\n"
+"if(this.nav['isOpera']){\n"
+"var start=this.textarea.selectionStart;\n"
+"var end= this.textarea.selectionEnd;\n"
+"var n = this.textarea.cloneNode(false);\n"
+"this.textarea.parentNode.replaceChild(n, this.textarea);\n"
+"this.textarea=document.getElementById(\"textarea\");\n"
+"this.area_select(start, end-start);\n"
+"}\n"
+"if(this.nav['isIE']){\n"
+"}\n"
+"this.last_line_selected=-1;\n"
+"this.textarea.focus();\n"
+"this.textareaFocused=true;\n"
+"this.last_selection[\"indexOfCursor\"]=-1;\n"
+"this.last_selection[\"curr_pos\"]=-1;\n"
+"this.last_selection[\"line_start\"]=-1;\n"
+"};\n"
+"EditArea.prototype.change_font_size= function(){\n"
+"var size=document.getElementById(\"area_font_size\").value;\n"
+"if(size>0)\n"
+"this.set_font(\"\", size);\n"
+"};\n"
+"EditArea.prototype.open_inline_popup= function(popup_id){\n"
+"this.close_all_inline_popup();\n"
+"var popup= document.getElementById(popup_id);\n"
+"var editor= document.getElementById(\"editor\");\n"
+"for(var i in this.inlinePopup){\n"
+"if(this.inlinePopup[i][\"popup_id\"]==popup_id){\n"
+"var icon= document.getElementById(this.inlinePopup[i][\"icon_id\"]);\n"
+"if(icon){\n"
+"this.switchClassSticky(icon, 'editAreaButtonSelected', true);\n"
+"break;\n"
+"}\n"
+"}\n"
+"}\n"
+"if(!popup.postionned){\n"
+"var new_left= editor.offsetWidth /2 - popup.offsetWidth /2;\n"
+"var new_top= editor.offsetHeight /2 - popup.offsetHeight /2;\n"
+"popup.style.left= new_left+\"px\";\n"
+"popup.style.top= new_top+\"px\";\n"
+"popup.postionned=true;\n"
+"}\n"
+"popup.style.visibility=\"visible\";\n"
+"};\n"
+"EditArea.prototype.close_inline_popup= function(popup_id){\n"
+"var popup= document.getElementById(popup_id);\n"
+"for(var i in this.inlinePopup){\n"
+"if(this.inlinePopup[i][\"popup_id\"]==popup_id){\n"
+"var icon= document.getElementById(this.inlinePopup[i][\"icon_id\"]);\n"
+"if(icon){\n"
+"this.switchClassSticky(icon, 'editAreaButtonNormal', false);\n"
+"break;\n"
+"}\n"
+"}\n"
+"}\n"
+"popup.style.visibility=\"hidden\";\n"
+"};\n"
+"EditArea.prototype.close_all_inline_popup= function(e){\n"
+"for(var i in this.inlinePopup){\n"
+"this.close_inline_popup(this.inlinePopup[i][\"popup_id\"]);\n"
+"}\n"
+"this.textarea.focus();\n"
+"};\n"
+"EditArea.prototype.show_help= function(){\n"
+"this.open_inline_popup(\"edit_area_help\");\n"
+"};\n"
+"EditArea.prototype.new_document= function(){\n"
+"this.textarea.value=\"\";\n"
+"this.area_select(0,0);\n"
+"};\n"
+"EditArea.prototype.get_all_toolbar_height= function(){\n"
+"var area= document.getElementById(\"editor\");\n"
+"var results= parent.getChildren(area, \"div\", \"class\", \"area_toolbar\", \"all\", \"0\");\n"
+"var height=0;\n"
+"for(var i in results){\n"
+"height+= results[i].offsetHeight;\n"
+"}\n"
+"return height;\n"
+"};\n"
+"EditArea.prototype.go_to_line= function(){\n"
+"var icon= document.getElementById(\"go_to_line_icon\");\n"
+"if(icon != null){\n"
+"this.restoreClass(icon);\n"
+"this.switchClassSticky(icon, 'editAreaButtonSelected', true);\n"
+"}\n"
+"var line= prompt(this.get_translation(\"go_to_line_prompt\"));\n"
+"if(line && line!=null && line.search(/^[0-9]+$/)!=-1){\n"
+"var start=0;\n"
+"var lines= this.textarea.value.split(\"\\n\");\n"
+"if(line > lines.length)\n"
+"start= this.textarea.value.length;\n"
+"else{\n"
+"for(var i=0; i< Math.min(line-1, lines.length); i++)\n"
+"start+= lines[i].length + 1;\n"
+"}\n"
+"this.area_select(start, 0);\n"
+"}\n"
+"if(icon != null)\n"
+"this.switchClassSticky(icon, 'editAreaButtonNormal', false);\n"
+"};\n"
+"EditArea.prototype.change_smooth_selection_mode= function(setTo){\n"
+"if(this.do_highlight)\n"
+"return;\n"
+"if(setTo != null){\n"
+"if(setTo === false)\n"
+"this.smooth_selection=true;\n"
+"else\n"
+"this.smooth_selection=false;\n"
+"}\n"
+"var icon= document.getElementById(\"change_smooth_selection_icon\");\n"
+"this.textarea.focus();\n"
+"if(this.smooth_selection===true){\n"
+"this.switchClassSticky(icon, 'editAreaButtonNormal', false);\n"
+"this.smooth_selection=false;\n"
+"document.getElementById(\"selection_field\").style.display= \"none\";\n"
+"document.getElementById(\"cursor_pos\").style.display= \"none\";\n"
+"document.getElementById(\"end_bracket\").style.display= \"none\";\n"
+"}else{\n"
+"this.switchClassSticky(icon, 'editAreaButtonSelected', false);\n"
+"this.smooth_selection=true;\n"
+"document.getElementById(\"selection_field\").style.display= \"block\";\n"
+"document.getElementById(\"cursor_pos\").style.display= \"block\";\n"
+"document.getElementById(\"end_bracket\").style.display= \"block\";\n"
+"}\n"
+"};\n"
+"EditArea.prototype.scroll_to_view= function(show){\n"
+"if(!this.smooth_selection)\n"
+"return;\n"
+"if(this.nav['isOpera']){\n"
+"}\n"
+"var zone= document.getElementById(\"result\");\n"
+"var cursor_pos_top= document.getElementById(\"cursor_pos\").cursor_top;\n"
+"if(show==\"bottom\")\n"
+"cursor_pos_top+= (this.last_selection[\"line_nb\"]-1)* this.lineHeight;\n"
+"var max_height_visible= zone.clientHeight + zone.scrollTop;\n"
+"var miss_top= cursor_pos_top + this.lineHeight - max_height_visible;\n"
+"if(miss_top>0){\n"
+"zone.scrollTop=  zone.scrollTop + miss_top;\n"
+"}else if( zone.scrollTop > cursor_pos_top){\n"
+"zone.scrollTop= cursor_pos_top;\n"
+"}\n"
+"var cursor_pos_left= document.getElementById(\"cursor_pos\").cursor_left;\n"
+"var max_width_visible= zone.clientWidth + zone.scrollLeft;\n"
+"var miss_left= cursor_pos_left + this.charWidth - max_width_visible;\n"
+"if(miss_left>0){\n"
+"zone.scrollLeft= zone.scrollLeft + miss_left+ 50;\n"
+"}else if( zone.scrollLeft > cursor_pos_left){\n"
+"zone.scrollLeft= cursor_pos_left ;\n"
+"}else if( zone.scrollLeft == 45){\n"
+"zone.scrollLeft=0;\n"
+"}\n"
+"};\n"
+"EditArea.prototype.check_undo= function(){\n"
+"if(this.textareaFocused && editAreas[this.id][\"displayed\"]==true){\n"
+"var text=this.textarea.value;\n"
+"if(this.previous.length<1)\n"
+"this.switchClassSticky(document.getElementById(\"undo_icon\"), 'editAreaButtonDisabled', true);\n"
+"if(this.previous[this.previous.length-1] != text){\n"
+"this.previous.push(text);\n"
+"if(this.previous.length > this.settings[\"max_undo\"]+1)\n"
+"this.previous.shift();\n"
+"}\n"
+"if(this.previous.length == 2)\n"
+"this.switchClassSticky(document.getElementById(\"undo_icon\"), 'editAreaButtonNormal', false);\n"
+"}\n"
+"setTimeout(\"editArea.check_undo()\", 1000);\n"
+"};\n"
+"EditArea.prototype.undo= function(){\n"
+"if(this.previous.length > 0){\n"
+"var pos_cursor=this.get_selection_infos()[\"indexOfCursor\"];\n"
+"this.next.push(this.textarea.value);\n"
+"var text= this.previous.pop();\n"
+"if(text==this.textarea.value && this.previous.length > 0)\n"
+"text=this.previous.pop();\n"
+"this.textarea.value= text;\n"
+"this.area_select(pos_cursor, 0);\n"
+"this.switchClassSticky(document.getElementById(\"redo_icon\"), 'editAreaButtonNormal', false);\n"
+"}\n"
+"};\n"
+"EditArea.prototype.redo= function(){\n"
+"if(this.next.length > 0){\n"
+"var pos_cursor=this.get_selection_infos()[\"indexOfCursor\"];\n"
+"var text= this.next.pop();\n"
+"this.previous.push(this.textarea.value);\n"
+"this.textarea.value= text;\n"
+"this.area_select(pos_cursor, 0);\n"
+"this.switchClassSticky(document.getElementById(\"undo_icon\"), 'editAreaButtonNormal', false);\n"
+"}\n"
+"if(	this.next.length == 0)\n"
+"this.switchClassSticky(document.getElementById(\"redo_icon\"), 'editAreaButtonDisabled', true);\n"
+"};\n"
+"EditArea.prototype.switchClass = function(element, class_name, lock_state) {\n"
+"var lockChanged = false;\n"
+"if (typeof(lock_state) != \"undefined\" && element != null) {\n"
+"element.classLock = lock_state;\n"
+"lockChanged = true;\n"
+"}\n"
+"if (element != null && (lockChanged || !element.classLock)) {\n"
+"element.oldClassName = element.className;\n"
+"element.className = class_name;\n"
+"}\n"
+"};\n"
+"EditArea.prototype.restoreAndSwitchClass = function(element, class_name) {\n"
+"if (element != null && !element.classLock) {\n"
+"this.restoreClass(element);\n"
+"this.switchClass(element, class_name);\n"
+"}\n"
+"};\n"
+"EditArea.prototype.restoreClass = function(element) {\n"
+"if (element != null && element.oldClassName && !element.classLock) {\n"
+"element.className = element.oldClassName;\n"
+"element.oldClassName = null;\n"
+"}\n"
+"};\n"
+"EditArea.prototype.setClassLock = function(element, lock_state) {\n"
+"if (element != null)\n"
+"element.classLock = lock_state;\n"
+"};\n"
+"EditArea.prototype.switchClassSticky = function(element, class_name, lock_state) {\n"
+"var lockChanged = false;\n"
+"if (typeof(lock_state) != \"undefined\" && element != null) {\n"
+"element.classLock = lock_state;\n"
+"lockChanged = true;\n"
+"}\n"
+"if (element != null && (lockChanged || !element.classLock)) {\n"
+"element.className = class_name;\n"
+"element.oldClassName = class_name;\n"
+"if (this.nav['isOpera']) {\n"
+"if (class_name == \"mceButtonDisabled\") {\n"
+"var suffix = \"\";\n"
+"if (!element.mceOldSrc)\n"
+"element.mceOldSrc = element.src;\n"
+"if (this.operaOpacityCounter > -1)\n"
+"suffix = '?rnd=' + this.operaOpacityCounter++;\n"
+"element.src = this.baseURL + \"/images/opacity.png\" ;\n"
+"element.style.backgroundImage = \"url('\" + element.mceOldSrc + \"')\";\n"
+"} else {\n"
+"if (element.mceOldSrc) {\n"
+"element.src = element.mceOldSrc;\n"
+"element.parentNode.style.backgroundImage = \"\";\n"
+"element.mceOldSrc = null;\n"
+"}\n"
+"}\n"
+"}\n"
+"}\n"
+"};\n"
+"EditArea.prototype.scroll_page= function(dir, shift_pressed){\n"
+"screen_height=document.getElementById(\"result\").clientHeight;\n"
+"var lines= this.textarea.value.split(\"\\n\");\n"
+"var new_pos=0;\n"
+"var length=0;\n"
+"var char_left=0;\n"
+"var line_nb=0;\n"
+"if(dir==\"up\"){\n"
+"var scroll_line= Math.ceil((screen_height -30)/this.lineHeight);\n"
+"if(this.last_selection[\"selec_direction\"]==\"up\"){\n"
+"for(line_nb=0; line_nb< Math.min(this.last_selection[\"line_start\"]-scroll_line, lines.length); line_nb++){\n"
+"new_pos+= lines[line_nb].length + 1;\n"
+"}\n"
+"char_left=Math.min(lines[Math.min(lines.length-1, line_nb)].length, this.last_selection[\"curr_pos\"]-1);\n"
+"if(shift_pressed)\n"
+"length=this.last_selection[\"selectionEnd\"]-new_pos-char_left;\n"
+"this.area_select(new_pos+char_left, length);\n"
+"view=\"top\";\n"
+"}else{\n"
+"view=\"bottom\";\n"
+"for(line_nb=0; line_nb< Math.min(this.last_selection[\"line_start\"]+this.last_selection[\"line_nb\"]-1-scroll_line, lines.length); line_nb++){\n"
+"new_pos+= lines[line_nb].length + 1;\n"
+"}\n"
+"char_left=Math.min(lines[Math.min(lines.length-1, line_nb)].length, this.last_selection[\"curr_pos\"]-1);\n"
+"if(shift_pressed){\n"
+"start= Math.min(this.last_selection[\"selectionStart\"], new_pos+char_left);\n"
+"length= Math.max(new_pos+char_left, this.last_selection[\"selectionStart\"] )- start ;\n"
+"if(new_pos+char_left < this.last_selection[\"selectionStart\"])\n"
+"view=\"top\";\n"
+"}else\n"
+"start=new_pos+char_left;\n"
+"this.area_select(start, length);\n"
+"}\n"
+"}else{\n"
+"var scroll_line= Math.floor((screen_height-30)/this.lineHeight);\n"
+"if(this.last_selection[\"selec_direction\"]==\"down\"){\n"
+"view=\"bottom\";\n"
+"for(line_nb=0; line_nb< Math.min(this.last_selection[\"line_start\"]+this.last_selection[\"line_nb\"]-2+scroll_line, lines.length); line_nb++){\n"
+"if(line_nb==this.last_selection[\"line_start\"]-1)\n"
+"char_left= this.last_selection[\"selectionStart\"] -new_pos;\n"
+"new_pos+= lines[line_nb].length + 1;\n"
+"}\n"
+"if(shift_pressed){\n"
+"length=Math.abs(this.last_selection[\"selectionStart\"]-new_pos);\n"
+"length+=Math.min(lines[Math.min(lines.length-1, line_nb)].length, this.last_selection[\"curr_pos\"]);\n"
+"this.area_select(Math.min(this.last_selection[\"selectionStart\"], new_pos), length);\n"
+"}else{\n"
+"this.area_select(new_pos+char_left, 0);\n"
+"}\n"
+"}else{\n"
+"view=\"top\";\n"
+"for(line_nb=0; line_nb< Math.min(this.last_selection[\"line_start\"]+scroll_line-1, lines.length, lines.length); line_nb++){\n"
+"if(line_nb==this.last_selection[\"line_start\"]-1)\n"
+"char_left= this.last_selection[\"selectionStart\"] -new_pos;\n"
+"new_pos+= lines[line_nb].length + 1;\n"
+"}\n"
+"if(shift_pressed){\n"
+"length=Math.abs(this.last_selection[\"selectionEnd\"]-new_pos-char_left);\n"
+"length+=Math.min(lines[Math.min(lines.length-1, line_nb)].length, this.last_selection[\"curr_pos\"])- char_left-1;\n"
+"this.area_select(Math.min(this.last_selection[\"selectionEnd\"], new_pos+char_left), length);\n"
+"if(new_pos+char_left > this.last_selection[\"selectionEnd\"])\n"
+"view=\"bottom\";\n"
+"}else{\n"
+"this.area_select(new_pos+char_left, 0);\n"
+"}\n"
+"}\n"
+"}\n"
+"this.check_line_selection();\n"
+"this.scroll_to_view(view);\n"
+"};\n"
+"EditArea.prototype.start_resize= function(e){\n"
+"parent.editAreaLoader.resize[\"id\"]= editArea.id;\n"
+"parent.editAreaLoader.resize[\"start_x\"]= (e)? e.pageX : event.x + document.body.scrollLeft;\n"
+"parent.editAreaLoader.resize[\"start_y\"]= (e)? e.pageY : event.y + document.body.scrollTop;\n"
+"if(editArea.nav['isIE']){\n"
+"editArea.textarea.focus();\n"
+"editArea.getIESelection();\n"
+"}\n"
+"parent.editAreaLoader.resize[\"selectionStart\"]= editArea.textarea.selectionStart;\n"
+"parent.editAreaLoader.resize[\"selectionEnd\"]= editArea.textarea.selectionEnd;\n"
+"parent.editAreaLoader.start_resize_area();\n"
+"};\n"
+"var clavier_cds=new Array(146);\n"
+"clavier_cds[8]=\"Retour arriere\";\n"
+"clavier_cds[9]=\"Tabulation\";\n"
+"clavier_cds[12]=\"Milieu (pave numerique)\";\n"
+"clavier_cds[13]=\"Entrer\";\n"
+"clavier_cds[16]=\"Shift\";\n"
+"clavier_cds[17]=\"Ctrl\";\n"
+"clavier_cds[18]=\"Alt\";\n"
+"clavier_cds[19]=\"Pause\";\n"
+"clavier_cds[20]=\"Verr Maj\";\n"
+"clavier_cds[27]=\"Echap\";\n"
+"clavier_cds[32]=\"Espace\";\n"
+"clavier_cds[33]=\"Page up\";\n"
+"clavier_cds[34]=\"Page down\";\n"
+"clavier_cds[35]=\"End\";\n"
+"clavier_cds[36]=\"Begin\";\n"
+"clavier_cds[37]=\"Fleche gauche\";\n"
+"clavier_cds[38]=\"Fleche haut\";\n"
+"clavier_cds[39]=\"Fleche droite\";\n"
+"clavier_cds[40]=\"Fleche bas\";\n"
+"clavier_cds[44]=\"Impr ecran\";\n"
+"clavier_cds[45]=\"Inser\";\n"
+"clavier_cds[46]=\"Suppr\";\n"
+"clavier_cds[91]=\"Menu Demarrer Windows / touche pomme Mac\";\n"
+"clavier_cds[92]=\"Menu Demarrer Windows\";\n"
+"clavier_cds[93]=\"Menu contextuel Windows\";\n"
+"clavier_cds[112]=\"F1\";\n"
+"clavier_cds[113]=\"F2\";\n"
+"clavier_cds[114]=\"F3\";\n"
+"clavier_cds[115]=\"F4\";\n"
+"clavier_cds[116]=\"F5\";\n"
+"clavier_cds[117]=\"F6\";\n"
+"clavier_cds[118]=\"F7\";\n"
+"clavier_cds[119]=\"F8\";\n"
+"clavier_cds[120]=\"F9\";\n"
+"clavier_cds[121]=\"F10\";\n"
+"clavier_cds[122]=\"F11\";\n"
+"clavier_cds[123]=\"F12\";\n"
+"clavier_cds[144]=\"Verr Num\";\n"
+"clavier_cds[145]=\"Arret defil\";\n"
+"function keyDown(e){\n"
+"if(!e){\n"
+"e=event;\n"
+"}\n"
+"var target_id=(e.target || e.srcElement).id;\n"
+"var use=false;\n"
+"if (clavier_cds[e.keyCode])\n"
+"letter=clavier_cds[e.keyCode];\n"
+"else\n"
+"letter=String.fromCharCode(e.keyCode);\n"
+"var low_letter= letter.toLowerCase();\n"
+"if(letter==\"Tabulation\" && target_id==\"textarea\"){\n"
+"if(ShiftPressed(e))\n"
+"editArea.invert_tab_selection();\n"
+"else\n"
+"editArea.tab_selection();\n"
+"use=true;\n"
+"if(editArea.nav['isOpera'])\n"
+"setTimeout(\"editArea.textarea.focus()\", 1);\n"
+"}else if(letter==\"Entrer\" && target_id==\"textarea\"){\n"
+"if(editArea.press_enter())\n"
+"use=true;\n"
+"}else if(letter==\"Page up\" && !editArea.nav['isOpera']){\n"
+"editArea.scroll_page(\"up\", ShiftPressed(e));\n"
+"use=true;\n"
+"}else if(letter==\"Page down\" && !editArea.nav['isOpera']){\n"
+"editArea.scroll_page(\"down\",ShiftPressed(e));\n"
+"use=true;\n"
+"}else if(CtrlPressed(e)){\n"
+"switch(low_letter){\n"
+"case \"f\":\n"
+"editArea.area_search();\n"
+"use=true;\n"
+"break;\n"
+"case \"r\":\n"
+"editArea.area_replace();\n"
+"use=true;\n"
+"break;\n"
+"case \"q\":\n"
+"editArea.close_all_inline_popup(e);\n"
+"use=true;\n"
+"break;\n"
+"case \"h\":\n"
+"date= new Date();\n"
+"if(!editArea.opera_last_fire_highlight)\n"
+"editArea.opera_last_fire_highlight=0;\n"
+"if(editArea.opera_last_fire_highlight < date.getTime() - 1000){\n"
+"editArea.opera_last_fire_highlight= date.getTime();\n"
+"editArea.change_highlight();\n"
+"}\n"
+"use=true;\n"
+"break;\n"
+"case \"g\":\n"
+"setTimeout(\"editArea.go_to_line();\", 5);\n"
+"use=true;\n"
+"break;\n"
+"case \"e\":\n"
+"editArea.show_help();\n"
+"use=true;\n"
+"break;\n"
+"default:\n"
+"break;\n"
+"}\n"
+"}\n"
+"if(use){\n"
+"if(editArea.nav['isIE'])\n"
+"e.keyCode=0;\n"
+"return false;\n"
+"}\n"
+"if(editArea.next.length > 0){\n"
+"editArea.next= new Array();\n"
+"editArea.switchClassSticky(document.getElementById(\"redo_icon\"), 'editAreaButtonDisabled', true);\n"
+"}\n"
+"return true;\n"
+"};\n"
+"function AltPressed(e) {\n"
+"if (window.event) {\n"
+"return (window.event.altKey);\n"
+"} else {\n"
+"if(e.modifiers)\n"
+"return (e.altKey || (e.modifiers % 2));\n"
+"else\n"
+"return e.altKey;\n"
+"}\n"
+"};\n"
+"function CtrlPressed(e) {\n"
+"if (window.event) {\n"
+"return (window.event.ctrlKey);\n"
+"} else {\n"
+"return (e.ctrlKey || (e.modifiers==2) || (e.modifiers==3) || (e.modifiers>5));\n"
+"}\n"
+"};\n"
+"function ShiftPressed(e) {\n"
+"if (window.event) {\n"
+"return (window.event.shiftKey);\n"
+"} else {\n"
+"return (e.shiftKey || (e.modifiers>3));\n"
+"}\n"
+"};\n"
+"	EditArea.prototype.show_search = function(){\n"
+"if(document.getElementById(\"area_search_replace\").style.visibility==\"visible\"){\n"
+"this.hidden_search();\n"
+"}else{\n"
+"this.open_inline_popup(\"area_search_replace\");\n"
+"var text= this.area_get_selection();\n"
+"var search= text.split(\"\\n\")[0];\n"
+"document.getElementById(\"area_search\").value= search;\n"
+"document.getElementById(\"area_search\").focus();\n"
+"}\n"
+"};\n"
+"EditArea.prototype.hidden_search= function(){\n"
+"this.close_inline_popup(\"area_search_replace\");\n"
+"};\n"
+"EditArea.prototype.area_search= function(mode){\n"
+"if(!mode)\n"
+"mode=\"search\";\n"
+"document.getElementById(\"area_search_msg\").innerHTML=\"\";\n"
+"var search=document.getElementById(\"area_search\").value;\n"
+"this.textarea.focus();\n"
+"this.textarea.textareaFocused=true;\n"
+"var infos= this.get_selection_infos();\n"
+"var start= infos[\"selectionStart\"];\n"
+"var pos=-1;\n"
+"var pos_begin=-1;\n"
+"var length=search.length;\n"
+"if(document.getElementById(\"area_search_replace\").style.visibility!=\"visible\"){\n"
+"this.show_search();\n"
+"return;\n"
+"}\n"
+"if(search.length==0){\n"
+"document.getElementById(\"area_search_msg\").innerHTML=this.get_translation(\"search_field_empty\");\n"
+"return;\n"
+"}\n"
+"if(mode!=\"replace\" ){\n"
+"if(document.getElementById(\"area_search_reg_exp\").checked)\n"
+"start++;\n"
+"else\n"
+"start+= search.length;\n"
+"}\n"
+"if(document.getElementById(\"area_search_reg_exp\").checked){\n"
+"var opt=\"m\";\n"
+"if(!document.getElementById(\"area_search_match_case\").checked)\n"
+"opt+=\"i\";\n"
+"var reg= new RegExp(search, opt);\n"
+"pos= infos[\"full_text\"].substr(start).search(reg);\n"
+"pos_begin= infos[\"full_text\"].search(reg);\n"
+"if(pos!=-1){\n"
+"pos+=start;\n"
+"length=infos[\"full_text\"].substr(start).match(reg)[0].length;\n"
+"}else if(pos_begin!=-1){\n"
+"length=infos[\"full_text\"].match(reg)[0].length;\n"
+"}\n"
+"}else{\n"
+"if(document.getElementById(\"area_search_match_case\").checked){\n"
+"pos= infos[\"full_text\"].indexOf(search, start);\n"
+"pos_begin= infos[\"full_text\"].indexOf(search);\n"
+"}else{\n"
+"pos= infos[\"full_text\"].toLowerCase().indexOf(search.toLowerCase(), start);\n"
+"pos_begin= infos[\"full_text\"].toLowerCase().indexOf(search.toLowerCase());\n"
+"}\n"
+"}\n"
+"if(pos==-1 && pos_begin==-1){\n"
+"document.getElementById(\"area_search_msg\").innerHTML=\"<strong>\"+search+\"</strong> \"+this.get_translation(\"not_found\");\n"
+"return;\n"
+"}else if(pos==-1 && pos_begin != -1){\n"
+"begin= pos_begin;\n"
+"document.getElementById(\"area_search_msg\").innerHTML=this.get_translation(\"restart_search_at_begin\");\n"
+"}else\n"
+"begin= pos;\n"
+"if(mode==\"replace\" && pos==infos[\"indexOfCursor\"]){\n"
+"var replace= document.getElementById(\"area_replace\").value;\n"
+"var new_text=\"\";\n"
+"if(document.getElementById(\"area_search_reg_exp\").checked){\n"
+"var opt=\"m\";\n"
+"if(!document.getElementById(\"area_search_match_case\").checked)\n"
+"opt+=\"i\";\n"
+"var reg= new RegExp(search, opt);\n"
+"new_text= infos[\"full_text\"].substr(0, begin) + infos[\"full_text\"].substr(start).replace(reg, replace);\n"
+"}else{\n"
+"new_text= infos[\"full_text\"].substr(0, begin) + replace + infos[\"full_text\"].substr(begin + length);\n"
+"}\n"
+"this.textarea.value=new_text;\n"
+"this.area_select(begin, length);\n"
+"this.area_search();\n"
+"}else\n"
+"this.area_select(begin, length);\n"
+"};\n"
+"EditArea.prototype.area_replace= function(){\n"
+"this.area_search(\"replace\");\n"
+"};\n"
+"EditArea.prototype.area_replace_all= function(){\n"
+"var base_text= this.textarea.value;\n"
+"var search= document.getElementById(\"area_search\").value;\n"
+"var replace= document.getElementById(\"area_replace\").value;\n"
+"if(search.length==0){\n"
+"document.getElementById(\"area_search_msg\").innerHTML=this.get_translation(\"search_field_empty\");\n"
+"return ;\n"
+"}\n"
+"var new_text=\"\";\n"
+"var nb_change=0;\n"
+"if(document.getElementById(\"area_search_reg_exp\").checked){\n"
+"var opt=\"mg\";\n"
+"if(!document.getElementById(\"area_search_match_case\").checked)\n"
+"opt+=\"i\";\n"
+"var reg= new RegExp(search, opt);\n"
+"nb_change= infos[\"full_text\"].match(reg).length;\n"
+"new_text= infos[\"full_text\"].replace(reg, replace);\n"
+"}else{\n"
+"if(document.getElementById(\"area_search_match_case\").checked){\n"
+"var tmp_tab=base_text.split(search);\n"
+"nb_change= tmp_tab.length -1 ;\n"
+"new_text= tmp_tab.join(replace);\n"
+"}else{\n"
+"var lower_value=base_text.toLowerCase()\n"
+"var lower_search=search.toLowerCase();\n"
+"var start=0;\n"
+"var pos= lower_value.indexOf(lower_search);\n"
+"while(pos!=-1){\n"
+"nb_change++;\n"
+"new_text+= this.textarea.value.substring(start , pos)+replace;\n"
+"start=pos+ search.length;\n"
+"pos= lower_value.indexOf(lower_search, pos+1);\n"
+"}\n"
+"new_text+= this.textarea.value.substring(start);\n"
+"}\n"
+"}\n"
+"if(new_text==base_text){\n"
+"document.getElementById(\"area_search_msg\").innerHTML=\"<strong>\"+search+\"</strong> \"+this.get_translation(\"not_found\");\n"
+"}else{\n"
+"this.textarea.value= new_text;\n"
+"document.getElementById(\"area_search_msg\").innerHTML=\"<strong>\"+nb_change+\"</strong> \"+this.get_translation(\"occurrence_replaced\");\n"
+"setTimeout(\"editArea.textarea.focus();editArea.textarea.textareaFocused=true;\", 100);\n"
+"}\n"
+"};\n"
+"\n"
+"EditArea.prototype.change_highlight= function(change_to){\n"
+"if(this.nav['isIE'])\n"
+"this.getIESelection();\n"
+"var pos_start= this.textarea.selectionStart;\n"
+"var pos_end= this.textarea.selectionEnd;\n"
+"if(this.do_highlight===true || change_to==false)\n"
+"this.disable_highlight();\n"
+"else\n"
+"this.enable_highlight();\n"
+"this.textarea.focus();\n"
+"this.textarea.selectionStart = pos_start;\n"
+"this.textarea.selectionEnd = pos_end;\n"
+"if(this.nav['isIE'])\n"
+"this.setIESelection();\n"
+"};\n"
+"EditArea.prototype.disable_highlight= function(displayOnly){\n"
+"document.getElementById(\"selection_field\").innerHTML=\"\";\n"
+"var contain=document.getElementById(\"content_highlight\");\n"
+"contain.style.visibility=\"hidden\";\n"
+"var new_Obj= contain.cloneNode(false);\n"
+"new_Obj.innerHTML= \"\";\n"
+"contain.parentNode.insertBefore(new_Obj, contain);\n"
+"contain.parentNode.removeChild(contain);\n"
+"var old_class= parent.getAttribute(this.textarea,\"class\");\n"
+"if(old_class){\n"
+"var new_class= old_class.replace(\"hidden\",\"\");\n"
+"parent.setAttribute(this.textarea, \"class\", new_class);\n"
+"}\n"
+"this.switchClassSticky(document.getElementById(\"highlight_icon\"), 'editAreaButtonNormal', false);\n"
+"this.switchClassSticky(document.getElementById(\"reset_highlight_icon\"), 'editAreaButtonDisabled', true);\n"
+"this.do_highlight=false;\n"
+"this.switchClassSticky(document.getElementById(\"change_smooth_selection_icon\"), 'editAreaButtonSelected', true);\n"
+"if(typeof(this.smooth_selection_before_highlight)!=\"undefined\" && this.smooth_selection_before_highlight===false){\n"
+"this.change_smooth_selection_mode(false);\n"
+"}\n"
+"};\n"
+"EditArea.prototype.enable_highlight= function(){\n"
+"width=document.getElementById(\"editor\").offsetWidth;\n"
+"height=document.getElementById(\"editor\").offsetHeight;\n"
+"if(this.nav['isGecko'] || this.nav['isOpera']){\n"
+"width-=2;\n"
+"height-=2;\n"
+"}\n"
+"if(this.textarea.value.length>0){\n"
+"this.should_display_processing_screen=true;\n"
+"document.getElementById(\"processing\").style.display=\"block\";\n"
+"document.getElementById(\"processing\").style.width= width+\"px\";\n"
+"document.getElementById(\"processing\").style.height= height+\"px\";\n"
+"}\n"
+"var contain=document.getElementById(\"content_highlight\");\n"
+"contain.style.visibility=\"visible\";\n"
+"var new_class=parent.getAttribute(this.textarea,\"class\")+\" hidden\";\n"
+"parent.setAttribute(this.textarea, \"class\", new_class);\n"
+"this.switchClassSticky(document.getElementById(\"highlight_icon\"), 'editAreaButtonSelected', false);\n"
+"this.switchClassSticky(document.getElementById(\"reset_highlight_icon\"), 'editAreaButtonNormal', false);\n"
+"this.smooth_selection_before_highlight=this.smooth_selection;\n"
+"if(!this.smooth_selection)\n"
+"this.change_smooth_selection_mode(true);\n"
+"this.switchClassSticky(document.getElementById(\"change_smooth_selection_icon\"), 'editAreaButtonDisabled', true);\n"
+"this.do_highlight=true;\n"
+"this.resync_highlight();\n"
+"};\n"
+"EditArea.prototype.maj_highlight= function(infos){\n"
+"if(this.last_highlight_base_text==infos[\"full_text\"] && this.resync_highlight!==true)\n"
+"return;\n"
+"if(infos[\"full_text\"].indexOf(\"\\r\")!=-1)\n"
+"text_to_highlight= infos[\"full_text\"].replace(/\\r/g, \"\");\n"
+"else\n"
+"text_to_highlight= infos[\"full_text\"];\n"
+"var start_line_pb=-1;\n"
+"var end_line_pb=-1;\n"
+"var stay_begin=\"\";\n"
+"var stay_end=\"\";\n"
+"var debug_opti=\"\";\n"
+"var date= new Date();\n"
+"var tps_start=date.getTime();\n"
+"var tps_middle_opti=date.getTime();\n"
+"if(this.reload_highlight===true){\n"
+"this.reload_highlight=false;\n"
+"}else if(text_to_highlight.length==0){\n"
+"text_to_highlight=\"\\n \";\n"
+"}else{\n"
+"var base_step=200;\n"
+"var cpt= 0;\n"
+"var end= Math.min(text_to_highlight.length, this.last_text_to_highlight.length);\n"
+"var step= base_step;\n"
+"while(cpt<end && step>=1){\n"
+"if(this.last_text_to_highlight.substr(cpt, step) == text_to_highlight.substr(cpt, step)){\n"
+"cpt+= step;\n"
+"}else{\n"
+"step= Math.floor(step/2);\n"
+"}\n"
+"}\n"
+"var pos_start_change=cpt;\n"
+"var line_start_change= text_to_highlight.substr(0, pos_start_change).split(\"\\n\").length -1;\n"
+"cpt_last= this.last_text_to_highlight.length;\n"
+"cpt= text_to_highlight.length;\n"
+"step= base_step;\n"
+"while(cpt>=0 && cpt_last>=0 && step>=1){\n"
+"if(this.last_text_to_highlight.substr(cpt_last-step, step) == text_to_highlight.substr(cpt-step, step)){\n"
+"cpt-= step;\n"
+"cpt_last-= step;\n"
+"}else{\n"
+"step= Math.floor(step/2);\n"
+"}\n"
+"}\n"
+"var pos_new_end_change= cpt;\n"
+"var pos_last_end_change= cpt_last;\n"
+"if(pos_new_end_change<=pos_start_change){\n"
+"if(this.last_text_to_highlight.length < text_to_highlight.length){\n"
+"pos_new_end_change= pos_start_change + text_to_highlight.length - this.last_text_to_highlight.length;\n"
+"pos_last_end_change= pos_start_change;\n"
+"}else{\n"
+"pos_last_end_change= pos_start_change + this.last_text_to_highlight.length - text_to_highlight.length;\n"
+"pos_new_end_change= pos_start_change;\n"
+"}\n"
+"}\n"
+"var change_new_text= text_to_highlight.substring(pos_start_change, pos_new_end_change);\n"
+"var change_last_text= this.last_text_to_highlight.substring(pos_start_change, pos_last_end_change);\n"
+"var line_new_end_change= text_to_highlight.substr(0, pos_new_end_change).split(\"\\n\").length -1;\n"
+"var line_last_end_change= this.last_text_to_highlight.substr(0, pos_last_end_change).split(\"\\n\").length -1;\n"
+"var change_new_text_line= text_to_highlight.split(\"\\n\").slice(line_start_change, line_new_end_change+1).join(\"\\n\");\n"
+"var change_last_text_line= this.last_text_to_highlight.split(\"\\n\").slice(line_start_change, line_last_end_change+1).join(\"\\n\");\n"
+"var trace_new= this.get_syntax_trace(change_new_text_line);\n"
+"var trace_last= this.get_syntax_trace(change_last_text_line);\n"
+"if(trace_new == trace_last){\n"
+"date= new Date();\n"
+"tps_middle_opti=date.getTime();\n"
+"stay_begin= this.last_hightlighted_text.split(\"\\n\").slice(0, line_start_change).join(\"\\n\");\n"
+"if(line_start_change>0)\n"
+"stay_begin+= \"\\n\";\n"
+"stay_end= this.last_hightlighted_text.split(\"\\n\").slice(line_last_end_change+1).join(\"\\n\");\n"
+"if(stay_end.length>0)\n"
+"stay_end= \"\\n\"+stay_end;\n"
+"text_to_highlight=change_new_text_line;\n"
+"}\n"
+"if(this.settings[\"debug\"]){\n"
+"debug_opti= (trace_new == trace_last)?\"Optimisation\": \"No optimisation\";\n"
+"debug_opti+= \" start: \"+pos_start_change +\"(\"+line_start_change+\")\";\n"
+"debug_opti+=\" end_new: \"+ pos_new_end_change+\"(\"+line_new_end_change+\")\";\n"
+"debug_opti+=\" end_last: \"+ pos_last_end_change+\"(\"+line_last_end_change+\")\";\n"
+"debug_opti+=\"\\nchanged_text: \"+change_new_text+\" => trace: \"+trace_new;\n"
+"debug_opti+=\"\\nchanged_last_text: \"+change_last_text+\" => trace: \"+trace_last;\n"
+"debug_opti+= \"\\nchanged_line: \"+change_new_text_line;\n"
+"debug_opti+= \"\\nlast_changed_line: \"+change_last_text_line;\n"
+"debug_opti+=\"\\nstay_begin: \"+ stay_begin.slice(-200);\n"
+"debug_opti+=\"\\nstay_end: \"+ stay_end;\n"
+"debug_opti+=\"\\n\";\n"
+"}\n"
+"}\n"
+"date= new Date();\n"
+"tps_end_opti=date.getTime();\n"
+"var updated_highlight= this.colorize_text(text_to_highlight);\n"
+"date= new Date();\n"
+"tps2=date.getTime();\n"
+"var hightlighted_text= stay_begin + updated_highlight + stay_end;\n"
+"date= new Date();\n"
+"inner1=date.getTime();\n"
+"var prev_Obj=document.getElementById(\"content_highlight\")\n"
+"var new_Obj= prev_Obj.cloneNode(false);\n"
+"if(this.nav['isIE'])\n"
+"new_Obj.innerHTML= \"<pre>\" + hightlighted_text.replace(\"\\n\", \"<br/>\") + \"</pre>\";\n"
+"else\n"
+"new_Obj.innerHTML= hightlighted_text;\n"
+"prev_Obj.parentNode.insertBefore(new_Obj,prev_Obj);\n"
+"prev_Obj.parentNode.removeChild(prev_Obj);\n"
+"if(infos[\"full_text\"].indexOf(\"\\r\")!=-1)\n"
+"this.last_text_to_highlight= infos[\"full_text\"].replace(/\\r/g, \"\");\n"
+"else\n"
+"this.last_text_to_highlight= infos[\"full_text\"];\n"
+"this.last_hightlighted_text= hightlighted_text;\n"
+"date= new Date();\n"
+"tps3=date.getTime();\n"
+"if(this.settings[\"debug\"]){\n"
+"tot1=tps_end_opti-tps_start;\n"
+"tot_middle=tps_end_opti- tps_middle_opti;\n"
+"tot2=tps2-tps_end_opti;\n"
+"tps_join=inner1-tps2;\n"
+"tps_td2=tps3-inner1;\n"
+"this.debug.value= \"Tps optimisation \"+tot1+\" (second part: \"+tot_middle+\") | tps reg exp: \"+tot2+\" | tps join: \"+tps_join;\n"
+"this.debug.value+= \" | tps update highlight content: \"+tps_td2+\"(\"+tps3+\")\\n\";\n"
+"this.debug.value+=debug_opti;\n"
+"}\n"
+"if(this.should_display_processing_screen){\n"
+"this.should_display_processing_screen= false;\n"
+"document.getElementById(\"processing\").style.display=\"none\";\n"
+"}\n"
+"};\n"
+"EditArea.prototype.resync_highlight= function(){\n"
+"this.reload_highlight=true;\n"
+"this.last_highlight_base_text=\"\";\n"
+"this.textarea.focus();\n"
+"this.textarea.textareaFocused=true;\n"
+"};\n"
+"\n"
+"EditArea.prototype.comment_or_quote= function(){\n"
+"var new_class=\"\";\n"
+"var close_tag=\"\";\n"
+"for(var i in parent.editAreaLoader.syntax[editArea.current_code_lang][\"quotes\"]){\n"
+"if(EditArea.prototype.comment_or_quote.arguments[0].indexOf(i)==0){\n"
+"new_class=\"quotesmarks\";\n"
+"close_tag=parent.editAreaLoader.syntax[editArea.current_code_lang][\"quotes\"][i];\n"
+"}\n"
+"}\n"
+"if(new_class.length==0)\n"
+"{\n"
+"for(var i in parent.editAreaLoader.syntax[editArea.current_code_lang][\"comments\"]){\n"
+"if(EditArea.prototype.comment_or_quote.arguments[0].indexOf(i)==0){\n"
+"new_class=\"comments\";\n"
+"close_tag=parent.editAreaLoader.syntax[editArea.current_code_lang][\"comments\"][i];\n"
+"}\n"
+"}\n"
+"}\n"
+"if(close_tag==\"\\n\"){\n"
+"return \"µ__\"+ new_class +\"__µ\"+EditArea.prototype.comment_or_quote.arguments[0].replace(/(\\r?\\n)?$/m, \"µ_END_µ$1\");\n"
+"}else{\n"
+"reg= new RegExp(parent.editAreaLoader.get_escaped_regexp(close_tag)+\"$\", \"m\");\n"
+"if(EditArea.prototype.comment_or_quote.arguments[0].search(reg)!=-1)\n"
+"return \"µ__\"+ new_class +\"__µ\"+EditArea.prototype.comment_or_quote.arguments[0]+\"µ_END_µ\";\n"
+"else\n"
+"return \"µ__\"+ new_class +\"__µ\"+EditArea.prototype.comment_or_quote.arguments[0];\n"
+"}\n"
+"};\n"
+"EditArea.prototype.get_syntax_trace= function(text){\n"
+"if(this.settings[\"syntax\"].length>0 && parent.editAreaLoader.syntax[this.settings[\"syntax\"]][\"syntax_trace_regexp\"])\n"
+"return text.replace(parent.editAreaLoader.syntax[this.settings[\"syntax\"]][\"syntax_trace_regexp\"], \"$3\");\n"
+"};\n"
+"EditArea.prototype.colorize_text= function(text){\n"
+"if(this.nav['isOpera']){\n"
+"text= this.replace_tab(text);\n"
+"}\n"
+"text= \" \"+text;\n"
+"if(this.settings[\"syntax\"].length>0)\n"
+"text= this.apply_syntax(text, this.settings[\"syntax\"]);\n"
+"text= text.substr(1);\n"
+"text= text.replace(/&/g,\"&amp;\");\n"
+"text= text.replace(/</g,\"&lt;\");\n"
+"text= text.replace(/>/g,\"&gt;\");\n"
+"text= text.replace(/µ_END_µ/g,\"</span>\");\n"
+"text= text.replace(/µ__([a-zA-Z0-9]+)__µ/g,\"<span class='$1'>\");\n"
+"return text;\n"
+"};\n"
+"EditArea.prototype.apply_syntax= function(text, lang){\n"
+"this.current_code_lang=lang;\n"
+"if(!parent.editAreaLoader.syntax[lang])\n"
+"return text;\n"
+"if(parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['before']){\n"
+"for( var i in parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['before']){\n"
+"var convert=\"$1µ__\"+ parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['before'][i]['class'] +\"__µ$2µ_END_µ$3\";\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['before'][i]['regexp'], convert);\n"
+"}\n"
+"}\n"
+"if(parent.editAreaLoader.syntax[lang][\"comment_or_quote_reg_exp\"]){\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"comment_or_quote_reg_exp\"], this.comment_or_quote);\n"
+"}\n"
+"if(parent.editAreaLoader.syntax[lang][\"keywords_reg_exp\"]){\n"
+"for(var i in parent.editAreaLoader.syntax[lang][\"keywords_reg_exp\"]){\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"keywords_reg_exp\"][i], 'µ__'+i+'__µ$2µ_END_µ');\n"
+"}\n"
+"}\n"
+"if(parent.editAreaLoader.syntax[lang][\"delimiters_reg_exp\"]){\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"delimiters_reg_exp\"], 'µ__delimiters__µ$1µ_END_µ');\n"
+"}\n"
+"if(parent.editAreaLoader.syntax[lang][\"operators_reg_exp\"]){\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"operators_reg_exp\"], 'µ__operators__µ$1µ_END_µ');\n"
+"}\n"
+"if(parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['after']){\n"
+"for( var i in parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['after']){\n"
+"var convert=\"$1µ__\"+ parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['after'][i]['class'] +\"__µ$2µ_END_µ$3\";\n"
+"text= text.replace(parent.editAreaLoader.syntax[lang][\"custom_regexp\"]['after'][i]['regexp'], convert);\n"
+"}\n"
+"}\n"
+"return text;\n"
+"};\n"
+"</script>";
editAreaLoader.template= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
+"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n"
+"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" >\n"
+"<head>\n"
+"<title>EditArea</title>\n"
+"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n"
+"[__CSSRULES__]\n"
+"[__JSCODE__]\n"
+"</head>\n"
+"<body>\n"
+"<div class='editor' id='editor'>\n"
+"<div class='area_toolbar' id='toolbar_1'>[__TOOLBAR__]</div>\n"
+"<div id='result'>\n"
+"<div id='container'>\n"
+"<div id='cursor_pos' class='edit_area_cursor'>&nbsp;</div>\n"
+"<div id='end_bracket' class='edit_area_cursor'>&nbsp;</div>\n"
+"<div id='selection_field' ></div>\n"
+"<div id='line_number' selec='none'></div>\n"
+"<div id='content_highlight'></div>\n"
+"<textarea id='textarea' wrap='off' onfocus='javascript:editArea.textareaFocused=true;' onblur='javascript:editArea.textareaFocused=false;'>\n"
+"</textarea>\n"
+"<span id='test_font_size'></span>\n"
+"</div>\n"
+"</div>\n"
+"<div class='area_toolbar' id='toolbar_2'>\n"
+"<table class='statusbar' cellspacing='0' cellpadding='0'>\n"
+"<tr>\n"
+"<td class='total' selec='none'>{$position}:</td>\n"
+"<td class='infos' selec='none'>\n"
+"{$line_abbr} <span  id='linePos'>0</span>, {$char_abbr} <span id='currPos'>0</span>\n"
+"</td>\n"
+"<td class='total' selec='none'>{$total}:</td>\n"
+"<td class='infos' selec='none'>\n"
+"{$line_abbr} <span id='nbLine'>0</span>, {$char_abbr} <span id='nbChar'>0</span>\n"
+"</td>\n"
+"<td class='resize'>\n"
+"<span id='resize_area'><img src='[__BASEURL__]images/statusbar_resize.gif' alt='resize'></span>\n"
+"</td>\n"
+"</tr>\n"
+"</table>\n"
+"</div>\n"
+"</div>\n"
+"<div id='processing'>\n"
+"<div id='processing_text'>\n"
+"{$processing}\n"
+"</div>\n"
+"</div>\n"
+"<div id='area_search_replace' class='editarea_popup'>\n"
+"<table cellspacing='2' cellpadding='0' style='width: 100%'>\n"
+"<tr>\n"
+"<td selec='none'>{$search}</td>\n"
+"<td><input type='text' id='area_search' /></td>\n"
+"<td id='close_area_search_replace'>\n"
+"<a onclick='Javascript:editArea.hidden_search()'><img selec='none' src='[__BASEURL__]images/close.gif' alt='{$close_popup}' title='{$close_popup}' /></a><br>\n"
+"</tr><tr>\n"
+"<td selec='none'>{$replace}</td>\n"
+"<td><input type='text' id='area_replace' /></td>\n"
+"<td><img id='move_area_search_replace' onmousedown='return parent.start_move_element(event,\"area_search_replace\", parent.frames[\"frame_\"+editArea.id]);'  src='[__BASEURL__]images/move.gif' alt='{$move_popup}' title='{$move_popup}' /></td>\n"
+"</tr>\n"
+"</table>\n"
+"<div class='button'>\n"
+"<input type='checkbox' id='area_search_match_case' /><label for='area_search_match_case' selec='none'>{$match_case}</label>\n"
+"<input type='checkbox' id='area_search_reg_exp' /><label for='area_search_reg_exp' selec='none'>{$reg_exp}</label>\n"
+"<br />\n"
+"<a onclick='Javascript:editArea.area_search()' selec='none'>{$find_next}</a>\n"
+"<a onclick='Javascript:editArea.area_replace()' selec='none'>{$replace}</a>\n"
+"<a onclick='Javascript:editArea.area_replace_all()' selec='none'>{$replace_all}</a><br />\n"
+"</div>\n"
+"<div id='area_search_msg' selec='none'></div>\n"
+"</div>\n"
+"<div id='edit_area_help' class='editarea_popup'>\n"
+"<div class='close_popup'>\n"
+"<a onclick='Javascript:editArea.close_all_inline_popup()'><img src='[__BASEURL__]images/close.gif' alt='close' title='{$close}' /></a>\n"
+"</div>\n"
+"<div><h2>Editarea</h2><br>\n"
+"<h3>{$shortcuts}:</h3>\n"
+"{$tab}: {$add_tab}<br>\n"
+"{$shift}+{$tab}: {$remove_tab}<br>\n"
+"{$ctrl}+f: {$search_command}<br>\n"
+"{$ctrl}+r: {$replace_command}<br>\n"
+"{$ctrl}+h: {$highlight}<br>\n"
+"{$ctrl}+g: {$go_to_line}<br>\n"
+"{$ctrl}+q: {$close_popup}<br>\n"
+"{$ctrl}+e: {$help}<br>\n"
+"{$accesskey} E: {$toogle}<br>\n"
+"<br>\n"
+"<em>{$about_notice}</em>\n"
+"<br><div class='copyright'>&copy; Christophe Dolivet - 2006</div>\n"
+"</div>\n"
+"</div>\n"
+"</div>\n"
+"</body>\n"
+"</html>\n"
+"";
editAreaLoader.iframe_css= "<style>body, html{\n"
+"margin: 0;\n"
+"padding: 0;\n"
+"height: 100%;\n"
+"border: none;\n"
+"overflow: hidden;\n"
+"}\n"
+"body, html, table, form, textarea{\n"
+"font: 12px monospace, sans-serif;\n"
+"}\n"
+"#editor{\n"
+"border: solid #888888 1px;\n"
+"overflow: hidden;\n"
+"}\n"
+"#result{\n"
+"z-index: 4;\n"
+"overflow: scroll;\n"
+"border-top: solid #888888 1px;\n"
+"border-bottom: solid #888888 1px;\n"
+"position: relative;\n"
+"}\n"
+"#container{\n"
+"overflow: hidden;\n"
+"border: solid blue 0px;\n"
+"position: relative;\n"
+"padding: 0 5px 0px 0;\n"
+"z-index: 10;\n"
+"}\n"
+"#textarea{\n"
+"position: relative;\n"
+"top: 0px;\n"
+"left: 0px;\n"
+"padding: 0px 0px 0px 45px;\n"
+"width: 100%;\n"
+"height: 100%;\n"
+"overflow: hidden;\n"
+"z-index: 7;\n"
+"border: solid green 0px;\n"
+"background-color: transparent;\n"
+"}\n"
+"#content_highlight{\n"
+"white-space: pre;\n"
+"padding: 1px 0 0 45px;\n"
+"position : absolute;\n"
+"z-index: 4;\n"
+"overflow: visible;\n"
+"border: solid yellow 0px;\n"
+"}\n"
+"#selection_field{\n"
+"padding: 0px 0px 0 45px;\n"
+"background-color: #FFFF99;\n"
+"height: 1px;\n"
+"position: absolute;\n"
+"z-index: 5;\n"
+"top: -100px;\n"
+"margin: 1px 0 0 0px;\n"
+"white-space: pre;\n"
+"overflow: hidden;\n"
+"}\n"
+"#line_number{\n"
+"position: absolute;\n"
+"overflow: hidden;\n"
+"border-right: solid black 1px;\n"
+"z-index:8;\n"
+"width: 38px;\n"
+"padding-right: 5px;\n"
+"text-align: right;\n"
+"color: #AAAAAA;\n"
+"}\n"
+"#test_font_size{\n"
+"padding: 0;\n"
+"margin: 0;\n"
+"visibility: hidden;\n"
+"border: solid red 0px;\n"
+"}\n"
+".hidden{\n"
+"opacity: 0.2;\n"
+"moz-opacity: 0.2;\n"
+"filter:alpha(opacity=20);\n"
+"}\n"
+"#result .edit_area_cursor{\n"
+"position: absolute;\n"
+"z-index:6;\n"
+"background-color: #FF6633;\n"
+"top: -100px;\n"
+"margin: 1px 0 0 0px;\n"
+"}\n"
+"#result .edit_area_selection_field .overline{\n"
+"background-color: #996600;\n"
+"}\n"
+".editarea_popup{\n"
+"border: solid 1px #888888;\n"
+"background-color: #ECE9D8;\n"
+"width: 250px;\n"
+"padding: 4px;\n"
+"position: absolute;\n"
+"visibility: hidden;\n"
+"z-index: 15;\n"
+"top: -500px;\n"
+"}\n"
+".editarea_popup, .editarea_popup table{\n"
+"font-family: sans-serif;\n"
+"font-size: 10pt;\n"
+"}\n"
+".editarea_popup img{\n"
+"border: 0;\n"
+"}\n"
+".editarea_popup .close_popup{\n"
+"float: right;\n"
+"line-height: 16px;\n"
+"border: 0px;\n"
+"padding: 0px;\n"
+"}\n"
+".editarea_popup h1,.editarea_popup h2,.editarea_popup h3,.editarea_popup h4,.editarea_popup h5,.editarea_popup h6{\n"
+"margin: 0px;\n"
+"padding: 0px;\n"
+"}\n"
+".editarea_popup .copyright{\n"
+"text-align: right;\n"
+"}\n"
+"div#area_search_replace{\n"
+"}\n"
+"div#area_search_replace img{\n"
+"border: 0px;\n"
+"}\n"
+"div#area_search_replace div.button{\n"
+"text-align: center;\n"
+"line-height: 1.7em;\n"
+"}\n"
+"div#area_search_replace .button a{\n"
+"cursor: pointer;\n"
+"border: solid 1px #888888;\n"
+"background-color: #DEDEDE;\n"
+"text-decoration: none;\n"
+"padding: 0 2px;\n"
+"color: #000000;\n"
+"}\n"
+"div#area_search_replace a:hover{\n"
+"background-color: #EDEDED;\n"
+"}\n"
+"div#area_search_replace  #move_area_search_replace{\n"
+"cursor: move;\n"
+"border: solid 1px #888888;\n"
+"}\n"
+"div#area_search_replace  #close_area_search_replace{\n"
+"text-align: right;\n"
+"vertical-align: top;\n"
+"white-space: nowrap;\n"
+"}\n"
+"div#area_search_replace  #area_search_msg{\n"
+"height: 18px;\n"
+"overflow: hidden;\n"
+"border-top: solid 1px #888888;\n"
+"margin-top: 3px;\n"
+"}\n"
+"#edit_area_help{\n"
+"width: 350px;\n"
+"}\n"
+"#edit_area_help div.close_popup{\n"
+"float: right;\n"
+"}\n"
+".area_toolbar{\n"
+"width: 100%;\n"
+"margin: 0px;\n"
+"padding: 0px;\n"
+"background-color: #ECE9D8;\n"
+"text-align: center;\n"
+"}\n"
+".area_toolbar, .area_toolbar table{\n"
+"font: 11px sans-serif;\n"
+"}\n"
+".area_toolbar img{\n"
+"border: 0px;\n"
+"vertical-align: middle;\n"
+"}\n"
+".area_toolbar input{\n"
+"margin: 0px;\n"
+"padding: 0px;\n"
+"}\n"
+".area_toolbar select{\n"
+"font-family: 'MS Sans Serif',sans-serif,Verdana,Arial;\n"
+"font-size: 7pt;\n"
+"font-weight: normal;\n"
+"margin: 2px 0 0 0 ;\n"
+"padding: 0;\n"
+"vertical-align: top;\n"
+"background-color: #F0F0EE;\n"
+"}\n"
+"table.statusbar{\n"
+"width: 100%;\n"
+"}\n"
+".area_toolbar td.infos{\n"
+"text-align: center;\n"
+"width: 130px;\n"
+"border-right: solid 1px #888888;\n"
+"border-width: 0 1px 0 0;\n"
+"padding: 0;\n"
+"}\n"
+".area_toolbar td.total{\n"
+"text-align: right;\n"
+"width: 50px;\n"
+"padding: 0;\n"
+"}\n"
+".area_toolbar td.resize{\n"
+"text-align: right;\n"
+"}\n"
+".area_toolbar span#resize_area{\n"
+"cursor: nw-resize;\n"
+"visibility: hidden;\n"
+"}\n"
+".editAreaButtonNormal, .editAreaButtonOver, .editAreaButtonDown, .editAreaSeparator, .editAreaSeparatorLine, .editAreaButtonDisabled, .editAreaButtonSelected {\n"
+"border: 0px; margin: 0px; padding: 0px; background: transparent;\n"
+"margin-top: 0px;\n"
+"margin-left: 1px;\n"
+"padding: 0px;\n"
+"}\n"
+".editAreaButtonNormal {\n"
+"border: 1px solid #ECE9D8 !important;\n"
+"cursor: pointer;\n"
+"}\n"
+".editAreaButtonOver {\n"
+"border: 1px solid #0A246A !important;\n"
+"cursor: pointer;\n"
+"background-color: #B6BDD2;\n"
+"}\n"
+".editAreaButtonDown {\n"
+"cursor: pointer;\n"
+"border: 1px solid #0A246A !important;\n"
+"background-color: #8592B5;\n"
+"}\n"
+".editAreaButtonSelected {\n"
+"border: 1px solid #C0C0BB !important;\n"
+"cursor: pointer;\n"
+"background-color: #F4F2E8;\n"
+"}\n"
+".editAreaButtonDisabled {\n"
+"filter:progid:DXImageTransform.Microsoft.Alpha(opacity=30);\n"
+"-moz-opacity:0.3;\n"
+"opacity: 0.3;\n"
+"border: 1px solid #F0F0EE !important;\n"
+"cursor: pointer;\n"
+"}\n"
+".editAreaSeparatorLine {\n"
+"margin: 1px 2px;\n"
+"background-color: #C0C0BB;\n"
+"width: 2px;\n"
+"height: 18px;\n"
+"}\n"
+"#processing{\n"
+"display: none;\n"
+"background-color:#ECE9D8;\n"
+"border: solid #888888 1px;\n"
+"position: absolute;\n"
+"top: 0;\n"
+"left: 0;\n"
+"width: 100%;\n"
+"height: 100%;\n"
+"z-index: 100;\n"
+"text-align: center;\n"
+"}\n"
+"#processing_text{\n"
+"position:absolute;\n"
+"left: 50%;\n"
+"top: 50%;\n"
+"width: 200px;\n"
+"height: 20px;\n"
+"margin-left: -100px;\n"
+"margin-top: -10px;\n"
+"text-align: center;\n"
+"}\n"
+"</style>";
